/**
 * @file NewDlg.h
 * @brief VKt@C̍쐬_CAO
 */
//---------------------------------------------------------------------------
#ifndef NewDlgH
#define NewDlgH

//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.Mask.hpp>

//---------------------------------------------------------------------------
/**
 * @brief VKt@C̍쐬_CAO
 */
class TNewFileDlg : public TForm
{
__published:	// IDE ŊǗR|[lg
	TAction *OkAction;
	TActionList *OK;
	TButton *CancelBtn;
	TButton *OkBtn;
	TButton *RefTplBtn;
	TComboBox *TplComboBox;
	TLabel *Label1;
	TLabeledEdit *NewExeCmdEdit;
	TLabeledEdit *NewNameEdit;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall TplComboBoxDrawItem(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State);
	void __fastcall RefTplBtnClick(TObject *Sender);
	void __fastcall TplComboBoxClick(TObject *Sender);
	void __fastcall OkActionUpdate(TObject *Sender);

private:	// [U[錾
	UnicodeString TplRefDir;

	void __fastcall WmFormShowed(TMessage &msg);

public:		// [U[錾
	__fastcall TNewFileDlg(TComponent* Owner);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_FORM_SHOWED,	TMessage,	WmFormShowed)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TNewFileDlg *NewFileDlg;
//---------------------------------------------------------------------------
#endif
