/**
 * @file Global.h
 * @brief O[oϐ/֐
 */
//---------------------------------------------------------------------------
#ifndef GlobalH
#define GlobalH

//---------------------------------------------------------------------------
#include <Vcl.BaseImageCollection.hpp>
#include <Vcl.ImageCollection.hpp>
#include <Vcl.VirtualImageList.hpp>

#include <htmlhelp.h>
#include <mmsystem.h>
#include "usr_scale.h"
#include "usr_file_ex.h"
#include "usr_shell.h"
#include "usr_arc.h"
#include "usr_migemo.h"
#include "usr_cmdlist.h"
#include "usr_scrpanel.h"
#include "usr_highlight.h"
#include "usr_tag.h"
#include "htmconv.h"
#include "UIniFile.h"
#include "UserFunc.h"
#include "MarkList.h"
#include "task_thread.h"
#include "imgv_thread.h"
#include "icon_thread.h"
#include "thumb_thread.h"

//---------------------------------------------------------------------------
/** @defgroup DEFINE ` */
/** @{ */
//---------------------------------------------------------------------------
#define SUPPORT_URL	"https://github.com/Nekomimi1958/NyanFi_x64s"
#define RELEASE_URL	"https://api.github.com/repos/Nekomimi1958/NyanFi_x64s/releases/latest"

//---------------------------------------------------------------------------
#define WM_FORM_SHOWED		(WM_APP + 1)	//!< tH[\ꂽ
#define WM_NYANFI_APPEAR	(WM_APP + 100)	//!< fUCAtHgAzFύXꂽ
#define WM_NYANFI_FLICON	(WM_APP + 101)	//!< ACR擾
#define WM_NYANFI_THUMBNAIL	(WM_APP + 102)	//!< TlC擾
#define WM_NYANFI_CLPCOPIED	(WM_APP + 103)	//!< Nbv{[hɃRs[
#define WM_NYANFI_PLAYLIST	(WM_APP + 104)	//!< vCXgʒm
#define WM_NYANFI_LOCKKEY	(WM_APP + 105)	//!< LockKeyMouse 쒆̃L[
#define WM_NYANFI_CLSEDITM	(WM_APP + 106)	//!< ݒ荀ڂ̕ҏW_CAO
#define WM_NYANFI_GREP_END	(WM_APP + 110)	//!< GREP

//---------------------------------------------------------------------------
//WM_COPYDATA bZ[W̎ʔԍ
#define CPYDTID_OPTIONS	1		//!< NIvV
#define CPYDTID_DPL_INF	2		//!< dN̉ʏ
#define CPYDTID_DPL_MSG	3		//!< dN̒ʒmbZ[W
#define CPYDTID_TXTVIEW	4		//!< eLXgr[AŊJ
#define CPYDTID_IMGVIEW	5		//!< C[Wr[AŊJ
#define CPYDTID_EXECMDS	6		//!< R}hs
/** @} */

//---------------------------------------------------------------------------
//Npob`t@C
extern UnicodeString RstBatName;		//!< ċNpob`t@C

//---------------------------------------------------------------------------
//HTMLwv
extern bool CancelHelp;					//!< [F1]ɃR}h蓖ĂĂwv}~

/**
 * @brief wvgsbNJ
 * @param topic gsbN
 */
void HtmlHelpTopic(const _TCHAR *topic);

/**
 * @brief wvJ
 * @param idx ReLXg
 */
void HtmlHelpContext(int idx);

/**
 * @brief t@C/L[[hw肵ăwvJ(hhh.exe)
 * @param fnam wvt@C
 * @param kwd L[[h
 */
void HtmlHelpKeyword(UnicodeString fnam, UnicodeString kwd);

/** @brief wv */
void CloseHelpWnd();

#define HELPTOPIC_TOP	"hid00001.htm"		//!< \
#define HELPTOPIC_FL	"hid00005.htm"		//!< t@C[ - R}h
#define HELPTOPIC_TV	"hid00006.htm"		//!< eLXgr[A
#define HELPTOPIC_IV	"hid00007.htm"		//!< C[Wr[A
#define HELPTOPIC_IS	"hid00050.htm"		//!< CN^T[`
#define HELPTOPIC_CI	"hid00100.htm"		//!< R}h̍
#define HELPTOPIC_CILW	"hid00100.htm#LW"	//!< R}h̍(OEBhE)
#define HELPTOPIC_FI	"hid00101.htm"		//!< R}h̍(@\)
#define HELPTOPIC_XC	"hid00063.htm"		//!< ExeCommands R}h
#define HELPTOPIC_GR	"hid00056.htm"		//!< 񌟍(GREP)
#define HELPTOPIC_RP	"hid00061.htm"		//!< u
#define HELPTOPIC_GIT	"hid00090.htm"		//!< Git̗p
#define HELPTOPIC_CH	"hid00109.htm"		//!< ύX

//---------------------------------------------------------------------------
//JAPI
typedef BOOL (WINAPI *FUNC_GetFontResourceInfo)(LPCWSTR, DWORD*, LPVOID, DWORD);
extern  HMODULE hGdi32;
extern  FUNC_GetFontResourceInfo	lpfGetFontResourceInfo;

//---------------------------------------------------------------------------
/** @addtogroup DEFINE */
/** @{ */

#define DEF_WIN_WIDTH	800
#define DEF_WIN_HEIGHT	600

/** @defgroup DEF_SCR_MODE ʃ[h(ScrMode) */
/** @{ */
#define SCMD_FLIST	1					//!< t@C[
#define SCMD_TVIEW	2					//!< eLXgr[A
#define SCMD_IVIEW	4					//!< C[Wr[A
#define SCMD_GREP	8					//!< GREP
/** @} */

#define MAX_FILELIST	 2				//!< t@CXg (E)
#define MAX_TASK_THREAD	 6				//!< ő^XN = 4 + 2(sp)

#define MAX_BGIMAGE		 6				//!< wi摜(wi*2/ E*2/ mu*2)
#define BGIMGID_KNOB_V	 4
#define BGIMGID_KNOB_H	 5

#define MAX_TABLIST	 	30				//!< ő^u

#define MAX_FNTZOOM_SZ	72				//!< őtHgTCY
#define MIN_FNTZOOM_SZ	2				//!< ŏtHgTCY

#define MAX_WORKHISTORY 50				//!< ő像[NXg
#define MAX_CMD_HISTORY 1000			//!< őR}h
#define MAX_FNCPY_HISTORY 50			//!< Rs[t@C̍ő嗚

#define CMPDEL_BUFF_SIZE 2048			//!< S폜̃obt@TCY
#define CRLF_DETECT_LINE 1000			//!< sR[h̍s

#define ID_CALL_HOTKEY	101
#define ID_APP_HOTKEY	102

#define TMP_ARC_F	"ARC~%04u"			//!< A[JCupꎞfBNg̏
#define TMP_ARC_P	"ARC~????"			//!< A[JCupꎞfBNǧp^[
#define TMP_FTP_D	"FTP~0000"			//!< FTPpꎞfBNg

#define FICO_INI_FILE "FolderIcon.INI"	//!< tH_ACR`
#define HILT_INI_FILE "Highlight.INI"	//!< \\`
#define DIR_HIST_FILE "DirHistory.INI"	//!< fBNgS̗
#define CALC_INI_FILE "Calculator.INI"	//!< d̒`
#define TAGDATA_FILE  "TAGDATA.TXT"		//!< ^Of[^
#define DRVLOG_FILE   "DriveLog.csv"	//!< hCueʃO
#define RENLOG_FILE   "renamelog.txt"	//!< O
#define RENLIST_FILE  "renamelist.txt"	//!< Xg
#define CLIP_BMP_FILE "CLIPBOARD.BMP"	//!< Nbv{[ḧꎞۑ

#define WEBMAP_FILE	  "$~WEBMAP.HTM"	//!< Web}bv\pt@C
#define WEBMAP_TPLT	  "WEBMAP.HTM"		//!< Web}bv\pev[g

#define RESPONSE_FILE "$~LISTFILE.TXT"	//!< X|Xt@C
#define RESPONSE_ERR  "ERROR"

#define DISTR_FILE	  "Distribute.INI"	//!< U蕪o^t@C

#define FONTSMPL_FILE "FontSample.INI"	//!< tHg{

#define SFX_AUTOREN   "_\\SN(1)"		//!< ftHg̎(TtBbNX)
#define FMT_AUTO_REN  "\\N" SFX_AUTOREN	//!< ftHg̎

#define LOG_ALL_TASK_RDY	"All Task Ready"

/** @defgroup DEF_CSVITMCNT CSV̍ڐ */
/** @{ */
#define EXTMENU_CSVITMCNT	6			//!< caption,cmd,prm,alias,show,icon
#define EXTTOOL_CSVITMCNT	6			//!< caption,exe,prm,wk_dir,alias,show
#define TABLIST_CSVITMCNT	9			//!< path0,path1,caption,icon,home0,home1,nwl_mode,nwl,sync_lr
#define DISTRLS_CSVITMCNT	4			//!< title,enable,mask,dist
#define REGDIR_CSVITMCNT	4			//!< key,title,path,user_name
#define MAX_CSV_ITEM	  255
/** @} */

/** @defgroup DEF_LISTBOX_TAG Xg{bNXpIvVtO
 * @details ListBox->Tag ɐݒ肵܂B@n
 * 2oCg = t@C:ږő啝/ o^fBNg:uꏊv̕\ʒu@n
 * 4rbg UserMdl Ŏgp
 */
/** @{ */
#define LBTAG_OPT_FIF1	0x00010000		//!< t@C(ŏ3s͊{)
#define LBTAG_OPT_FIF2	0x00020000		//!< t@C
#define LBTAG_OPT_SDIR	0x00040000		//!< tH_ꗗ(ϐgp)
#define LBTAG_OPT_TREE	0x00080000		//!< c[\
#define LBTAG_OPT_ZOOM	0x00100000		//!< Y[\
#define LBTAG_OPT_LNNO	0x00200000		//!< sԍ\
#define LBTAG_OPT_LCPY	0x00400000		//!< 1sRs[\
#define LBTAG_OPT_LOOP	0x00800000		//!< [vړ
#define LBTAG_GEN_LIST	0x01000000		//!< ꗗ_CAO
#define LBTAG_FIF_LIST	0x02000000		//!< t@C_CAO
#define LBTAG_TAB_FNAM	0x04000000		//!< ^uȍ~Ƀt@C
#define LBTAG_VAR_LIST	0x08000000		//!< uO=lv`
/** @} */

//---------------------------------------------------------------------------
#define SHOW_WARN_TAG	-1

//---------------------------------------------------------------------------
//Ɏ󂯕tR}h
#define ONFIND_CMD	"CursorUp|CursorDown|PageUp|PageDown|CurrToOpp|FileEdit|BinaryEdit|OpenByApp|OpenByWin|OpenStandard|Select"

//---------------------------------------------------------------------------
//load_ImageFile ̖߂l
#define LOADED_BY_STD	1		//!< WICW
#define LOADED_BY_WIC	2		//!< WIC̑

//---------------------------------------------------------------------------
enum SeaOpt {soMigemo, soRegEx, soAndOr, soFuzzy, soCaseSens, soWord, soBytes, soFromPos,
			 soCSV, soTSV, soTree, soGitGrep, soGrep, soGrepS, soGrepF};
typedef Set <SeaOpt, soMigemo, soGrepF> SearchOption;	//!< pIvV

/** @} */

//---------------------------------------------------------------------------
/** @brief dNỈʏ */
struct win_dat {
//CEBhE
	int WinTop;
	int WinLeft;
	int WinWidth;
	int WinHeight;
	TWindowState WinState;
	int WinPPI;
//Tupl
	int SubHeight;
	int SubWidth;
	int InfWidth;
	int InfHeight;
	int ImageWidth;
	int ImageHeight;
	int TailHeight;
//̑
	bool ShowFileListOnly;
};

//---------------------------------------------------------------------------
extern TCursor crTmpPrev;		//!< J[\̃vr[p

//---------------------------------------------------------------------------
extern UnicodeString KeyStr_SELECT;

extern UnicodeString KeyStr_Copy;
extern UnicodeString KeyStr_Cut;
extern UnicodeString KeyStr_Migemo;
extern UnicodeString KeyStr_RegEx;
extern UnicodeString KeyStr_Word;
extern UnicodeString KeyStr_Case;

extern UnicodeString KeysStr_Filter;
extern UnicodeString KeysStr_ToList;
extern UnicodeString KeysStr_ToKeywd;
extern UnicodeString KeysStr_ToMask;

extern UnicodeString KeysStr_CsrDown;
extern UnicodeString KeysStr_CsrUp;
extern UnicodeString KeysStr_PgDown;
extern UnicodeString KeysStr_PgUp;
extern UnicodeString KeysStr_Popup;

extern UnicodeString TabPinMark;		//!< ^uŒs}[N
extern UnicodeString HEAD_Mark;			//!< git HEAD }[N
extern UnicodeString PLAY_Mark;			//!< Đ}[N

extern UnicodeString SortIdStr;

//---------------------------------------------------------------------------
extern HWND   MainHandle;				//!< CEBhẼnh
extern DWORD  ProcessId;				//!< vZXID
extern bool   IsAdmin;					//!< ǗҌ
extern bool   IsPrimary;				//!< ŏɋNꂽ
extern bool   GitExists;				//!< Git CXg[Ă
extern bool   GrepExists;				//!< grep.exe CXg[Ă
extern bool   IsMuted;					//!< ʃ~[g
extern int    StartedCount;				//!< sJnJEg(mb)
extern int    NyanFiIdNo;				//!< d NyanFi ID
extern bool   NoRoundWin;				//!< pۃEBhE}~

extern int    ScrMode;					//!< ʃ[h

extern UnicodeString VclStyle;			//!< VCLX^C

extern MarkList *ErrMarkList;

extern TRect  FileListRect;

extern TRichEdit *TempRichEdit;

extern TTaskThread *TaskThread[MAX_TASK_THREAD];	//!< ^XNXbh
extern bool gTaskCancel[MAX_TASK_THREAD];
extern bool gTaskPause[MAX_TASK_THREAD];
extern int  MaxTasks;						//!< ő^XN
extern bool RsvSuspended;					//!< \ۗ̕
extern TaskConfigList *TaskReserveList;		//!< ^XN\񃊃Xg
extern int  LastOpCount;					//!< Ōɑ삵Ƃ̃JEgl

extern TImgViewThread   *ImgViewThread;		//!< 摜r[Xbh
extern TThumbnailThread *ThumbnailThread;	//!< TlC擾Xbh
extern TGetIconThread   *GetIconThread;		//!< ACR擾Xbh

extern UserArcUnit *usr_ARC;				//!< A[JCujbg
extern UnicodeString FExt7zDll;				//!< 7z.dll őΉgq

extern MigemoUnit  *usr_Migemo;				//!< Migemo jbg
extern UnicodeString MigemoPath;			//!< Migemo fBNg
extern bool LastMigemoMode;
extern bool LastMigemoModeF;

extern int  WicScaleOpt;			//!< WIC̏kEgASY
extern UnicodeString WicFextStr;	//!< WICΉĂgq

extern bool gCopyAll;
extern bool gCopyCancel;

extern int  gCopyMode;				//!< EʃfBNg̏ꍇ̃Rs[[h
extern int  gCopyMode2;				//!< EfBNg̏ꍇ̃Rs[[h
extern int  xCopyMode;				//!< ExeCommand ŗp鋭[h

#define CPYMD_OW			0
#define CPYMD_NEW			1
#define CPYMD_SKIP			2
#define CPYMD_AUT_REN		3
#define CPYMD_MAN_REN		4
#define CPYMD_REN_CLONE		5
#define CPYMD_NEW_BACKUP	10

extern UnicodeString gCopyFmt;

extern int OptionPageIndex;			//!< IvVݒ_CAÕy[WCfbNX

extern bool SyncLR;					//!< ẼfBNgύX𓯊

extern UnicodeString GlobalErrMsg;

extern bool Initialized;			//!< 
extern bool UnInitializing;			//!< IJnꂽ
extern bool Closing;				//!< I

extern int  InhReload;				//!< Reload ̗}~
extern bool DisReload;				//!< Reload ̖

extern bool InhUpdate;			  	//!< UpdateList }~
extern bool InhCmdHistory;  		//!< R}h̗}~

extern UnicodeString FindPath;
extern bool FindAborted;			//!< fv
extern bool FindDiff;				//!< DiffDir s
extern int  FindTag;
extern int  FindCount;				//!< }b`

extern bool CalcAborted;			//!< vZfv
extern int  CalcTag;

extern bool GitGrepAborted;			//!< GitGrep ̒fv

//---------------------------------------------------------------------------
extern bool MultiInstance;			//!< dN
extern bool CloseOthers;			//!< NyanFiI
extern bool StoreTaskTray;			//!< ŏɃ^XNgCɊi[
extern bool ShowDirType;			//!< DIRʂ\
extern bool ShowSpace;				//!< 󔒂\
extern bool UseIndIcon;				//!< t@CŗL̃ACRgp
extern bool ShowHideAtr;			//!< Bt@C\
extern bool ShowSystemAtr;			//!< VXet@C\
extern bool DispRegName;			//!< pX̕\ɓo^p
extern bool UncToNetDrive;			//!< UNClbg[NhCu
extern bool CompInTitleBar;			//!< ^Cgo[ɃRs[^\
extern bool PathInTitleBar;			//!< ^Cgo[ɃJgpX\
extern bool TabGrInTitleBar;		//!< ^Cgo[Ƀ^OO[v\
extern bool OmitEndOfName;			//!< O͖ȗ
extern bool ShowAdsInf;				//!< փf[^Xg[\
extern bool ShowUseProcInf;			//!< vZXgp\
extern bool ShowDirJumboIco;		//!< fBNg͓ACR\
extern bool ShowInZipImg;			//!< ZIP̉摜\
extern bool PreviewAniGif;			//!< Aj[VGIF̃vr[
extern bool SetPrvCursor;			//!< vr[Ń}EXJ[\ݒ
extern bool ForceDel;				//!< Ǎpt@CIɏ㏑E폜
extern bool RemoveCdReadOnly;		//!< CD-ROM̃Rs[ɓǍp
extern bool CopyTags;				//!< ^ORs[
extern bool CopyNoBuffering;		//!< obt@[ȂI/OgpăRs[
extern bool ShowArcCopyProg;
extern bool DelUseTrash;			//!< t@C̍폜ɃS~g
extern bool EditNewText;			//!< VKeLXg쐬ɃGfB^ŊJ
extern bool ViewArcInf;				//!< A[JCũt@C\
extern bool CheckTS;				//!< gq .ts (MPEG2-TS/TypeScript)̔ʂs
extern bool ReloadOnActive;			//!< ANeBuɍŐV̏
extern bool OpenAddedDrive;			//!< hCuǉꂽJgɕ\
extern bool CheckUnc;				//!< UNCpX`FbN
extern bool ShowMsgHint;			//!< xȂǂqg\
extern bool ShowKeyHint;			//!< 2Xg[Ñqg\
extern bool ShowNoKeyHint;			//!< 2Xg[Ňxo
extern bool ShowCopyHint;			//!< Nbv{[hւ̃Rs[qg\
extern bool ShowDuplNotify;			//!< dNꂽNyanFi̒ʒm\
extern bool ShowTooltip;			//!< c[`bv\
extern bool LogErrOnly;				//!< ^XNŃG[ӏ݂̂O\
extern bool LogErrMsg;				//!< OɃG[bZ[Wo
extern bool LogDebugInf;			//!< OɃfobOo
extern bool LogHideSkip;			//!< OɃXLbvڂo͂Ȃ
extern bool LogFullPath;			//!< ȌetpXŕ\
extern bool LogDestination;			//!< Oɏ\
extern bool SaveLog;				//!< IɃOۑ
extern bool AppendLog;				//!< ̃O͒ǋLۑ
extern bool NotSortWorkList;		//!< [NXgڂ\[gȂ
extern bool RegWorkCsrPos;			//!< J[\ʒuɓo^
extern bool AutoDelWorkList;		//!< ݂Ȃڂ폜
extern bool NoCheckWorkUnc;			//!< [NXgUNC`FbNȂ
extern bool AddToRecent;			//!< ŋߎgڂɒǉ
extern bool NoCheckRecentUnc;		//!< UNCpX`FbNȂ
extern bool DirHistCsrPos;			//!< fBNgŃJ[\ʒuL
extern bool DirHistSortMode;		//!< fBNgŃ\[g@L
extern bool DelDplDirHist;			//!< dfBNg폜
extern bool WorkToDirHist;			//!< [NXg𗚗Ɋ܂߂
extern bool NoCheckDirHist;			//!< fBNg̑݃`FbNsȂ
extern bool ExtSaveDirHist;			//!< S̗ʃt@Cɕۑ
extern bool LoopFilerCursor;		//!< t@C[ŃJ[\[vړ
extern bool FlCursorVisible;		//!< t@C[ŃJ[\ɉ̈
extern bool AutoCompComboBox;		//!< R{{bNX͂⊮
extern bool DialogCenter;			//!< _CAOCʂ̒
extern bool InhbitAltMenu;			//!< ALTL[Ńj[ɃtH[JXȂ
extern bool SelectByMouse;			//!< }EXŃt@C[̍ڂI
extern bool SelectBaseOnly;			//!< t@C啔ł̂ݑI
extern bool SelectIconSngl;			//!< ACRŌʂɑI
extern bool TimColEnabled;			//!< ^CX^v̔zFL
extern bool PriorFExtCol;			//!< gq͑FD
extern bool ColorOnlyFExt;			//!< gqʔzF͊gq݂̂ɓKp
extern bool SymColorToName;			//!< t@C啔ɃV{bNNFKp
extern bool RevTagColor;			//!< ^OF̔]\
extern bool InactiveGray;			//!< ANeBuȃCʂ̈ꕔO[
extern bool ShowMainMenu;			//!< Cj[\
extern bool ShowImgPreview;			//!< C[Wvr[\
extern bool ShowProperty;			//!< t@C\
extern bool ShowLogWin;				//!< OEBhE\
extern bool ShowFileListOnly;		//!< t@CXĝ݂\
extern bool ShowFileListOnly2;
extern bool ShowSttBar;				//!< Xe[^Xo[\
extern bool ShowToolBar;			//!< c[o[\(t@C[)
extern bool ShowToolBarV;			//!< c[o[\(eLXgr[A)
extern bool ShowToolBarI;			//!< c[o[\(C[Wr[A)
extern bool ToolBarISide;			//!< c[o[TCho[ɕ\(C[Wr[A)
extern bool ShowTabBar;				//!< ^uo[\
extern bool ShowFKeyBar;			//!< t@NVL[o[\
extern bool ShowClsTabBtn;			//!< ^u̕{^\
extern bool ShowPopTabBtn;			//!< ^ú{^\
extern bool ShowPopDirBtn;			//!< fBNǵ{^\
extern bool HideScrBar;				//!< cXN[o[B
extern bool ShowByteSize;			//!< oCgPʕ\
extern bool ShowTargetInf;			//!< ̂̏ŕ\
extern bool ShowHeader;				//!< wb_\
extern bool FixListWidth;			//!< XgŒ
extern bool KeepOnResize;			//!< EBhETCYύXɔ䗦ێ
extern bool KeepCurListWidth;		//!< Jg̃Xgێ
extern bool NoSpaceFExt;			//!< gq𕪗Ȃ
extern bool HideTitleMenu;			//!< ő剻Ƀ^Cgo[ƃj[B
extern bool ShowLineNo;				//!< sԍ\
extern bool ShowLineCursor;			//!< sJ[\\
extern bool ShowTAB;				//!< ^u\
extern bool ShowCR;					//!< s\
extern bool ShowIndent;				//!< CfgKCh\
extern bool ShowTextRuler;			//!< [\
extern bool ShowSticky;				//!< XeBbL[\
extern bool ScrBarToFoldPos;		//!< XN[o[܂Ԃʒuɕ\
extern bool TxtSttIsBottom;			//!< wb_ɕ\(TV)
extern bool ChkAozora;				//!< 󕶌Ɍ`l
extern bool UseXd2tx;				//!< xd2txlib.dll ŃeLXg\
extern bool ClickableUrl;			//!< _uNbNURLJ
extern bool RestoreViewLine;		//!< r[AŃJ[\̍sʒu𕜌
extern bool EmpComment;				//!< Rg\
extern bool EmpStrings;				//!< \
extern bool EmpReserved;			//!< \\
extern bool EmpSymbol;				//!< V{\
extern bool EmpNumeric;				//!< l\
extern bool EmpHeadline;			//!< o\
extern bool EmpRuby;				//!< r\
extern bool RotViewImg;				//!< Exifɂĉ摜]
extern bool KeepZoomRatio;			//!< ʂ̉摜ɈڂɃY[{ێ
extern bool ShowThumbName;			//!< TlCɃt@C\
extern bool ShowThumbExif;			//!< TlCɊȈExif\
extern bool ShowThumbTags;			//!< TlCɃ^O\
extern bool ShowThumbFExt;			//!< TlCɊgq\
extern bool NotThumbIfArc;			//!< A[JCu͈ꊇ擾Ȃ
extern bool CacheThumbADS;			//!< TlCADSɃLbV
extern bool LoopViewCursor;			//!< C[Wr[AŃJ[\[vړ
extern bool HintTopEndImg;			//!< 擪EŌŃqg\
extern bool BeepTopEndImg;			//!< x
extern bool ImgSttIsBottom;			//!< wb_ɕ\(IV)
extern bool SeekBindDir;			//!< V[No[̎n_Ԃɍ킹
extern bool SeekSwapNxtPrv;			//!< EԂNext/PrevFile
extern bool HideCsrInFull;			//!< Sʕ\Ń}EXJ[\B
extern bool HideThumbInFull;		//!< Sʕ\ŃTlCB
extern bool AnimateGif;				//!< C[Wr[AŃAj[VGIF\
extern bool ShowThumbScroll;		//!< TlC̃XN[o[\
extern bool ShowHistogram;			//!< qXgO\
extern bool ShowLoupe;				//!< [y\
extern bool ShowSubViewer;			//!< GIFr[A\
extern bool ShowSeekBar;			//!< V[No[\
extern bool WarnHighlight;			//!< ьx
extern bool DoublePage;				//!< J\
extern bool RightBind;				//!< EԂ

extern UnicodeString JpWrapChar1;	//!< s֑
extern UnicodeString JpWrapChar2;	//!< s֑
extern bool WordWrap;				//!< [hbv

extern bool PermitDotCmds;			//!< .nyanfi ŃR}hs
extern bool InheritDotNyan;			//!< ʃfBNg .nyanfi p
extern bool DotNyanPerUser;			//!< [Uʂ .nyanfi 쐬
extern int  InitialModeI;			//!< C[Wr[AJ̏
extern int  LastZoomRatio;			//!< ÕY[

extern bool MarkImgClose;			//!< C[Wr[A鎞ɞx}[Nݒ
extern UnicodeString MarkImgPath;	//!< }[NpX
extern UnicodeString MarkImgFExt;	//!< }[Ngq
extern UnicodeString MarkImgMemo;

extern int  IconMode;				//!< ACR̕\[h		0:\/ 1:\/ 2:fBNĝݕ\
extern int  ScrBarStyle;			//!< XN[o[EX^C	0:W/ 1:Vv/ 2:3/4/ 3:1/2/ 4:摜

extern bool ModalScreen;			//!< [_\
extern int  ModalScrAlpha;			//!< XN[̓x
extern TColor col_ModalScr;			//!< [_\ʐF

extern TColor col_bgOptTab;			//!< ANeBuȐݒ^u̔wiF
extern TColor col_fgOptTab;			//!< ANeBuȐݒ^u̕F

extern int TlWinBorderWidth;		//!< c[EChE̋E

extern UnicodeString DlgMoveShift;	//!< _CAOړ̃VtgL[
extern UnicodeString DlgSizeShift;	//!< _CAÕTCYύX̃VtgL[
extern int DlgMovePrm;
extern int DlgSizePrm;

extern int DblClickFlMode;				//!< t@CXgł̃_uNbN

extern UnicodeString WheelCmdF[4];		//!< zC[R}h
extern UnicodeString WheelCmdV[4];
extern UnicodeString WheelCmdI[4];

extern UnicodeString WheelBtnCmdF[4];	//!< zC[{^Ƃ̃R}h
extern UnicodeString WheelBtnCmdV;
extern UnicodeString WheelBtnCmdI;

extern UnicodeString X1BtnCmdF;			//!< X1{^Ƃ̃R}h
extern UnicodeString X2BtnCmdF;			//!< X2{^Ƃ̃R}h
extern UnicodeString X1BtnCmdV;
extern UnicodeString X2BtnCmdV;
extern UnicodeString X1BtnCmdI;
extern UnicodeString X2BtnCmdI;

extern UnicodeString EmpBinPtn1;		//!< oCip^[1
extern UnicodeString EmpBinPtn2;		//!< oCip^[2
extern UnicodeString EmpBinPtn3;		//!< oCip^[3

extern UnicodeString HtmInsHrCls;		//!< ubN̑OɌr}NX
extern UnicodeString HtmHdrStr;			//!< o
extern bool HtmInsHrSct;				//!< <section>̑OɌr}
extern bool HtmInsHrArt;				//!< <article>̑OɌr}
extern bool HtmInsHrNav;				//!< <nav>̑OɌr}
extern bool ToMarkdown;					//!< MarkdownL@ɕϊ
extern UnicodeString HtmDelBlkCls;		//!< 폜ubN class
extern UnicodeString HtmDelBlkId;		//!< 폜ubN id

extern UnicodeString NoWatchPath;		//!< fBNgĎ珜OpX

extern UnicodeString FExtGetInf;		//!< t@C擾gq
extern UnicodeString FExtNoInf;			//!< t@C擾Ȃgq
extern UnicodeString NoInfPath;			//!< t@C擾ȂpX
extern UnicodeString EmpInfItems;		//!< \t@C񍀖(|؂)
extern TStringList  *HideInfItems;		//!< Bt@C񍀖(gq=|؂`̃Xg)

extern UnicodeString FExtImgPrv;		//!< C[Wvr[sgq
extern UnicodeString FExtNoImgPrv;		//!< C[Wvr[sȂgq
extern UnicodeString NoImgPrvPath;		//!< C[Wvr[sȂpXXg

extern UnicodeString FExtNoIView;		//!< C[Wr[Aŉ{Ȃgq
extern UnicodeString NoCachePath;		//!< TlCLbVȂpX

extern UnicodeString DrvInfFmtR;		//!< hCȕ : [g
extern UnicodeString DrvInfFmtS;		//!< hCȕ : I
extern UnicodeString DrvInfFmtN;		//!< hCȕ : ̑

extern UnicodeString SttBarFmt;			//!< Xe[^Xo[̏
extern UnicodeString SttClockFmt;		//!< v̏

extern int  MaxLogFiles;				//!< Ot@C̕ۑ㐔
extern int  MaxDirHistory;				//!< fBNg̕ۑ

extern int  ProtectDirMode;				//!< fBNg̍폜[h
extern bool ProtectSubDir;				//!< ʃfBNg
extern bool ProtectFile;				//!< t@C

extern bool WarnPowerFail;				//!< dؒfx
extern bool WarnDisconnect;				//!< C^[lbgڑ؂
extern bool WarnLowBattery;				//!< obe[ቺ
extern int  BatLowerLimit;

extern int  BorderMoveWidth;			//!< BorderLeftABorderRight: P̈ړ
extern UnicodeString AutoRenFmt;		//!< CopyAMove: ̎
extern int  RemoteWaitTime;				//!< R[obÑEFCg^C
extern int  NormalWaitTime;
extern int  NopDtctTime;				//!< 삾Ƃ݂Ȃ
extern int  TimeTolerance;				//!< ^CX^v̋e덷

extern bool AppListChgMin;				//!< AppList:   Avɐ؂ւƂɍŏ
extern bool CreDirChg;					//!< CreateDir: fBNg쐬ɃJgύX
extern bool CreDirCnvChar;				//!< CreateDir: uKp
extern UnicodeString FExtExeFile;		//!< ExeCommandLine: st@CƂ݂Ȃgq
extern bool OpenOnlyCurEdit;			//!< FileEdit:  IԂɂ炸J[\ʒû݂J
extern bool DontClrSelEdit;				//!< FileEdit:  IȂ
extern int  OpenByMode;					//!< OpenByApp:  ֘AtĂȂꍇ̓샂[h
extern bool OpenDirByStd;				//!< OpenByApp:  fBNgł͕W Enter L[
extern bool OpenOnlyCurApp;				//!< OpenByApp:  IԂɂ炸J[\ʒû݂J
extern bool DontClrSelApp;				//!< OpenByApp:  IȂ
extern bool OpenOnlyCurWin;				//!< OpenByWin:  IԂɂ炸J[\ʒû݂J
extern bool DontClrSelWin;				//!< OpenByWin:  IȂ
extern bool OpenStdTabGroup;			//!< OpenStandard: ^uO[vJ
extern bool OpenStdMenuFile;			//!< OpenStandard: j[t@CJ
extern bool OpenStdResultList;			//!< OpenStandard: ʃXgJ
extern bool OpenStdFindSet;				//!< OpenStandard: ݒJ
extern bool DownAfterOpenStd;			//!< OpenStandard: sɃJ[\Ɉړ
extern bool OpenStdOnResList;			//!< OpenStandard: ʃXgłʏ퓮
extern UnicodeString IniSeaShift;		//!< IniSearch:  T[`̃VtgL[
extern bool IniSeaByNum;				//!<   L[łT[`
extern bool IniSeaBySign;				//!<   Shift+L[̋LT[`
extern bool IncSeaCaseSens;				//!< IncSearch: 召
extern bool IncSeaFuzzy;				//!< IncSearch: ܂
extern bool IncSeaLoop;					//!< IncSearch: ㉺[Ń[v
extern bool IncSeaMatch1Exit;			//!< IncSearch: }b`1Ŕ
extern int  IncSeaMigemoMin;			//!< IncSearch: Migemo ̌Jn
extern bool SyncItem;					//!< SyncLR : ڈʒu
extern bool NotShowNoTask;				//!< TaskMan: ^XNsĂȂƂ̓}l[W\Ȃ
extern UnicodeString GetFaviconUrl;		//!< favicon 擾API

extern bool FindPathColumn;				//!< ʃXgɁuꏊv\
extern int  FindPathWidth;				//!< uꏊv̍ŏ
extern bool FindTagsColumn;				//!< ʃXgɁu^Ov\
extern int  FindTagsWidth;				//!< u^Ov̍ŏ

extern bool GrepNotUpdList;				//!< GREPɌʃXgXVȂ
extern bool RepNotUpdList;				//!< ꊇuɌʃXgXVȂ
extern bool GrepShowItemNo;				//!< GREPʂɍڔԍ\
extern bool GrepFileItemNo;				//!< ڔԍt@CPʂŕ\
extern bool GrepShowSubDir;				//!< GREPʂɃTufBNg\
extern bool GrepTrimTop;				//!< GREPʂōs̃^u󔒂폜
extern bool GrepOmitTop;				//!< GREPʂŃ}b`ꂪȂƂOȗ
extern bool GrepEmFilter;				//!< GREPʂŃtB^̌\
extern bool GrepAdjNextLn;				//!< GREPʂŎs\̖x
extern int  GrepOutMode;				//!< GREP o͐	0:/ 1:t@C/ 2:Nbv{[h
extern UnicodeString GrepFileName;		//!< o̓t@C
extern UnicodeString GrepAppName;		//!< NAv
extern UnicodeString GrepAppParam;		//!< Av̋Np[^
extern UnicodeString GrepAppDir;		//!< Av̍ƃfBNg
extern bool GrepAppEnabled;				//!< AvL
extern bool GrepAppend;					//!< t@Cɒǉ
extern UnicodeString GrepFileFmt;		//!< t@C̏
extern UnicodeString GrepInsStrW;		//!< }b`Ȏ}
extern UnicodeString GrepInsStrW2;		//!< }b`̑}
extern bool GrepTrimLeft;				//!< s̃^u󔒂폜
extern bool GrepReplaceTab;				//!< ^u1ɒu
extern bool GrepReplaceCr;				//!< s𕶎ɒu
extern UnicodeString GrepRepCrStr;		//!< s̒u
extern bool BackupReplace;				//!< uobNAbv쐬
extern UnicodeString FExtRepBackup;		//!< uobNAbv̊gq
extern UnicodeString RepBackupDir;		//!< uobNAbv
extern UnicodeString ReplaceLogName;	//!< uOt@C
extern bool SaveReplaceLog;				//!< uOۑ
extern bool ReplaceAppend;				//!< t@Cɒǉ
extern bool OpenReplaceLog;				//!< OeLXgGfB^ŊJ

extern UnicodeString UserName;			//!< [U
extern UnicodeString TempPath;			//!< ꎞfBNg
extern UnicodeString TempPathA;			//!< ꎞfBNg()
extern UnicodeString TempPathFTP;		//!< FTPpꎞfBNg()

extern UnicodeString DownloadPath;		//!< _E[hp
extern UnicodeString LibraryPath;		//!< Cu
extern UnicodeString WorkListPath;		//!< [NXgQƃpX
extern UnicodeString ResultListPath;	//!< ʃXgQƃpX
extern UnicodeString ListFilePath;		//!< Xgt@CQƃpX
extern UnicodeString FindSetPath;		//!< ʎQƃpX
extern UnicodeString RefParamPath;		//!< p[^QƃpX
extern UnicodeString CmdFilePath;		//!< R}ht@CQƃpX
extern UnicodeString CmdGitExe;			//!< git.exe
extern UnicodeString GitBashExe;		//!< git-bash.exe
extern UnicodeString GitGuiExe;			//!< git-gui.exe
extern UnicodeString CmdGrepExe;		//!< grep.exe

extern int VersionNo;
extern UnicodeString VersionStr;		//!< o[W\
extern UnicodeString OSVerInfStr;		//!< OSo[W
extern bool IsWin11;					//!< Windows 11 H

extern UnicodeString DirBraStr;			//!< fBNgʕ
extern UnicodeString DirKetStr;
extern UnicodeString TimeStampFmt;		//!< ^CX^v̕\

extern UnicodeString CallHotKey;		//!< ĂяozbgL[
extern UnicodeString AppListHotKey;		//!< AvꗗzbgL[
extern UnicodeString AppListHotPrm;		//!< Avꗗp[^

extern UnicodeString SaveTxtPath;		//!< eLXgۑpX
extern int SaveEncIndex;				//!< GR[fBÕCfbNX

extern UnicodeString NoDirHistPath;		//!< fBNgɓȂpX
extern UnicodeString NoEditHistPath;	//!< ҏWɓȂpX
extern UnicodeString NoViewHistPath;	//!< {ɓȂpX
extern UnicodeString NoRepoListPath;	//!< |Wgꗗɕ\ȂpX

extern UnicodeString DirDelimiter;		//!< fBNg؂̕\

extern bool NoCheckUncRPT;				//!< UNCpX̃p[X|Cg`FbNȂ

extern int  InactiveAdjust;				//!< ANeBuO[̍ł̉l

extern int CurTabIndex;					//!< ^uCfbNX(0`)

extern UnicodeString CurPathName;
extern int CurListTag;					//!< Jg^O  0:/ 1:E
extern int OppListTag;					//!< Α^O
extern int LastCurTag;					//!< OĨJg
extern int WorkingTag;					//!< Ƒ̃^O(CurWorking = true )

extern UnicodeString FTPTextModeFExt;	//!< eLXg[hœ]gq
extern bool FTPDlKeepTime;				//!< _E[ht@C̃^CX^vێ
extern bool FTPUpKeepTime;				//!< Abv[ht@C̃^CX^vێ
extern bool FTPUpToLower;				//!< t@CăAbv[h
extern bool FTPLogResponse;				//!< bZ[WOɕ\
extern int  FTPRemoteSide;				//!< [g 0:Jg/ 1:/ 2:E
extern int  FTPDisconTimeout;			//!< FTP̏ꍇؒf鎞

extern UnicodeString FTPSndConnect;		//!< ڑ̒ʒm
extern UnicodeString FTPSndDiscon;		//!< ؒf̒ʒm
extern UnicodeString FTPSndTransfer;	//!< ]̒ʒm

extern UnicodeString FTPPathName;

extern TListBox *FileListBox[MAX_FILELIST];		//!< t@CXg{bNX
extern TPanel	*FileListPanel[MAX_FILELIST];

extern UnicodeString ViewFileName;		//!< \̃t@C
extern UnicodeString ViewFileName2;
extern bool ViewFromArc;				//!< A[JCu\

//---------------------------------------------------------------------------
#define GENLST_FILELIST	1
#define GENLST_DRIVE	2
#define GENLST_CMDSLIST	3
#define GENLST_TABLIST	4
#define GENLST_ICON		5
#define GENLST_FONT		6

extern TStringList *GeneralList;		//!< TStringList ̃Xg(ꊇjp)

//---------------------------------------------------------------------------
/** @defgroup FILELIST t@CXg̑ */
/** @{ */
extern TStringList *FileList[MAX_FILELIST];			//!< t@CXg
extern TStringList *ArcFileList[MAX_FILELIST];		//!< zfBNg̃t@CXg
extern TStringList *AdsFileList[MAX_FILELIST];		//!< փf[^Xg[̃t@CXg
extern TStringList *ResultList[MAX_FILELIST];		//!< ʃXg
extern TStringList *SelMaskList[MAX_FILELIST];		//!< I}XNXg
extern TStringList *TmpBufList[MAX_FILELIST];		//!< ꎞޔXg
/** @} */

extern TStringList *DriveInfoList;		//!< hCu
extern TStringList *DriveLogList;		//!< hCueʃO
extern UnicodeString DriveLogName;		//!< hCueʃÕt@C

extern TStringList *WatchTailList;		//!< ĎXg
extern UnicodeString LastWatchLog;		//!< O̊ĎO

extern TStringList *InvalidUncList;		//!< UNCXg

extern TStringList *GitCfgUrlList;		//!< .Git\config - URL ΉXg (t@C=URL \t yyyy/mm/dd hh:nn:ss)
extern TStringList *GitInfList;			//!< Git̃LbV

extern TStringList *TabList;			//!< ^uXg
extern TStringList *TabBuff;			//!< Œ蕜Apobt@
extern int FlTabWidth;					//!< ^u̕
extern int FlTabStyle;					//!< ^ũX^C
extern UnicodeString TabGroupName;		//!< ^uO[vEt@C

extern TStringList *CachedIcoList;		//!< t@CŗLACR̃LbV (IconRWLock ŕی삷邱)
extern TMultiReadExclusiveWriteSynchronizer *IconRWLock;
extern int IconCache;					//!< ACRLV

extern UsrIniFile  *FolderIconFile;		//!< tH_ACRݒt@C
extern TStringList *FolderIconList;		//!< tH_ACRXg
extern TMultiReadExclusiveWriteSynchronizer *FldIcoRWLock;
extern UnicodeString DefFldIcoName;		//!< ftHg̃tH_ACR
extern HICON hLinkIcon;					//!< N}[N(Shell32.dll,29)

extern TStringList *GeneralIconList;	//!< t@CXg\p̈ʃACR
extern TStringList *MenuBtnIcoList;
extern TStringList *UsrIcoList;			//!< j[Ac[{^pACR
extern TStringList *DrvIcoList;			//!< hCũACRXg

extern TStringList *BakSetupList;		//!< obNAbvݒ胊Xg
extern TStringList *SyncDirList;		//!< Rs[惊Xg
extern TStringList *AssRenList;			//!< ֘At@Cݒ胊Xg
extern TStringList *DistrDefList;		//!< U蕪`Xg

extern TStringList *GrepPathList;		//!< GREP ΏۃpX̃Xg
extern TStringList *GrepFileList;		//!< GREP Ώۃt@CXg
extern TStringList *GrepResultBuff;		//!< GREP ʃXg\pobt@
extern TStringList *GrepResultList;		//!< GREP ̌ʃXg
extern TStringList *GrepStashBuff;		//!< GREP ʂ̑ޔobt@
extern TStringList *GrepUnsortBuff;		//!< GREP \[gOobt@
extern TStringList *GrepMatchList;		//!< GREP t@Cʃ}b`Xg
extern int  ResultListMode;				//!< ʃXg̓e	0:/ 1:GREP/ 2:u

extern TStringList *ViewFileList;		//!< C[Wr[Ał̃t@CXg
extern bool isViewIcon;					//!< C[Wr[AŃACR\
extern bool isViewAGif;					//!< C[Wr[AŃAj[VGIF\
extern bool isViewClip;					//!< C[Wr[AŃNbv{[h\
extern bool isViewFTP;					//!< C[Wr[AFTP̃t@C\
extern bool rqThumbnail;				//!< Nbv{[h/FTP{̃TlCAv
extern bool nrmThumbnail;				//!< ʏʎ̃TlC\

extern TStringList *LaunchList;			//!< `[Xg(AvP[Vꗗ)

extern UnicodeString PathMask[MAX_FILELIST];	//!< pX}XN
extern UnicodeString DriveInf[MAX_FILELIST];	//!< hCu

extern TStringList *WorkList;			//!< [NXg
extern UnicodeString WorkListName;		//!< [NXg̃t@C
extern TDateTime WorkListTime;			//!< [NXg̃^CX^v
extern bool WorkListChanged;			//!< [NXg̓eύXꂽ
extern bool WorkListFiltered;			//!< [NXgɃtB^KpĂ
extern bool WorkListHasSep;				//!< [NXgɃZp[^
extern bool rqWorkListDirInf;			//!< [NXg̃fBNgXVv

extern TStringList *PlayList;			//!< vCXg
extern UnicodeString PlayListFile;		//!< vCXg̃t@C
extern UnicodeString PlayFile;			//!< Đt@C
extern int  PlayStbIdx;
extern bool PlayRepeat;					//!< s[gĐ
extern bool PlayShuffle;				//!< VbtĐ
extern bool ListShuffled;				//!< Vbtꂽ

extern int  IniPathMode[MAX_FILELIST];				//!< NpX[h
extern UnicodeString InitialPath[MAX_FILELIST];		//!< NpX
extern UnicodeString InitialMask[MAX_FILELIST];		//!< N}XN
extern int  IniSortMode[MAX_FILELIST];				//!< N\[g@

extern int  IniWorkMode;				//!< [NXg 0:O/ 1:w
extern UnicodeString HomeWorkList;

extern TStringList *PopMenuList;		//!< ExeMenuFile R}hpj[
extern TStringList *ToolBtnList;		//!< c[{^`Xg(t@C[)
extern TStringList *ToolBtnListV;		//!< c[{^`Xg(eLXgr[A)
extern TStringList *ToolBtnListI;		//!< c[{^`Xg(C[Wr[A)

extern int  IniWinMode;					//!< TCY[h 0:O/ 1:w
extern int  IniWinLeft, IniWinTop, IniWinWidth, IniWinHeight;
extern bool FixWinPos;					//!< EBhETCYŒ
extern bool IniPathToTab1;				//!< pX^u1ɐݒ
extern bool IniTabHomeAll;				//!< pXȊÕ^uz[ɖ߂
extern bool ShowSplash;					//!< XvbV\

//---------------------------------------------------------------------------
/**
 * @defgroup OPTION_EVENT_CMDS IvVݒ - Cxg
 * @brief CxgɎsR}h
*/

/** @{ */
#define MAX_EVENT_CMD	66	//!< őCxg

extern UnicodeString OnAppStart;
extern UnicodeString OnAppClose;
extern UnicodeString OnMaximized;
extern UnicodeString OnMinimized;
extern UnicodeString OnRestored;
extern UnicodeString OnCurChange;
extern UnicodeString OnTabChange;
extern UnicodeString OnNewDrive;
extern UnicodeString OnArcOpend;
extern UnicodeString OnArcClosed;
extern UnicodeString OnFindOpend;
extern UnicodeString OnFlCursor;
extern UnicodeString OnFlExDClick;
extern UnicodeString OnFlTbRClick;
extern UnicodeString OnTabDClick;
extern UnicodeString OnTabRClick;
extern UnicodeString OnFlRClick;
extern UnicodeString OnDragStart;
extern UnicodeString OnDragEnd;
extern UnicodeString OnGrepOpen;
extern UnicodeString OnGrepClosed;
extern UnicodeString OnWatchNotify;
extern UnicodeString OnFTPConnect;
extern UnicodeString OnFTPDiscon;
extern UnicodeString OnDirDClick;
extern UnicodeString OnDirRClick;
extern UnicodeString OnRelDClick;
extern UnicodeString OnRelRClick;
extern UnicodeString OnHdrRClick;
extern UnicodeString OnFScrRClick;
extern UnicodeString OnDrvDClick;
extern UnicodeString OnDrvRClick;
extern UnicodeString OnSplDClick;
extern UnicodeString OnSplRClick;
extern UnicodeString OnImgDClick;
extern UnicodeString OnTxtDClick;
extern UnicodeString OnFlIDClick;
extern UnicodeString OnTskDClick;
extern UnicodeString OnTskRClick;
extern UnicodeString OnLogDClick;
extern UnicodeString OnSttDClick;
extern UnicodeString OnSttRClick;
extern UnicodeString OnTimDClick;
extern UnicodeString OnTimRClick;
extern UnicodeString OnTvOpen;
extern UnicodeString OnTvOpened;
extern UnicodeString OnTvClose;
extern UnicodeString OnTvClosed;
extern UnicodeString OnTvTbRClick;
extern UnicodeString OnTvHRClick;
extern UnicodeString OnIvOpened;
extern UnicodeString OnIvClosed;
extern UnicodeString OnFullScr;
extern UnicodeString OnNormScr;
extern UnicodeString OnIvTbRClick;
extern UnicodeString OnIvImgDClick;
extern UnicodeString OnIvImgRClick;
extern UnicodeString OnIvMgnDClick;
extern UnicodeString OnThmDClick;
extern UnicodeString OnThmRClick;
extern UnicodeString OnIvIDClick;
extern UnicodeString OnIvSbRClick;
extern UnicodeString OnDragStartI;
extern UnicodeString OnDragEndI;
extern UnicodeString OnClipText;
extern UnicodeString OnUnlocked;

struct event_rec {
	UnicodeString *sp;	//!< ϐ̃|C^
	const _TCHAR *key;	//!< L[
	const _TCHAR *dsc;	//!< 
};

extern const event_rec EventCmdList[MAX_EVENT_CMD];	//!< CxgR}hXg

/** @} */

//---------------------------------------------------------------------------
#define MAX_TIMER_EVENT	2
#define MAX_TIMER_ALARM	6
extern bool Timer_Enabled[MAX_TIMER_EVENT], Timer_NopAct[MAX_TIMER_EVENT];
extern int  Timer_StartCnt[MAX_TIMER_EVENT], Timer_TimeCnt[MAX_TIMER_EVENT], Timer_NopCnt[MAX_TIMER_EVENT];
extern int  Timer_RepeatN[MAX_TIMER_EVENT], Timer_RepeatCnt[MAX_TIMER_EVENT];
extern TStringList  *Timer_AlarmList[MAX_TIMER_EVENT];
extern UnicodeString Timer_Condition[MAX_TIMER_EVENT];
extern UnicodeString OnTimerEvent[MAX_TIMER_EVENT];

//---------------------------------------------------------------------------
extern int  SortMode[MAX_FILELIST];			/**< t@CXg̃\[g@@n
											 * 0:O/ 1:gq/ 2:XV/ 3:TCY/ 4:/ 5:Ȃ */
extern int  DirSortMode[MAX_FILELIST];		/**< fBNg̃\[g@@n
											 * 0:t@CƓ/ 1:O/ 2:XV/ 3:TCY/ 4:/
											 * 5:fBNgʂȂ/ 6:tH_ACR */
extern int  SubSortMode[5];					//!< 2\[g[h
extern int  PrimeSortMode;					//!< 1\[g[h

extern bool FlOdrNatural[MAX_FILELIST];		//!< R
extern bool FlOdrDscName[MAX_FILELIST];		//!< ~
extern bool FlOdrSmall[MAX_FILELIST];		//!< 
extern bool FlOdrOld[MAX_FILELIST];			//!< Â
extern bool FlOdrDscAttr[MAX_FILELIST];		//!< ~
extern bool FlOdrDscPath[MAX_FILELIST];		//!< ꏊ~

extern bool NaturalOrder;					//!< r֐ - R
extern bool DscNameOrder;					//!< r֐ - O~
extern bool SmallOrder;						//!< r֐ - 
extern bool OldOrder;						//!< r֐ - Â
extern bool DscAttrOrder;					//!< r֐ - ~
extern bool DscPathOrder;					//!< r֐ - ꏊ~

extern bool TopSymbol;
extern bool SortBoth;						//!< EƂύX
extern bool SortLogical;					//!< _\[g(R\[g)
extern UnicodeString SortSymList;
extern UnicodeString SortExtList;			//!< gqŗD悷gq

extern TStringList *OptionList;				//!< IvV
extern TStringList *KeyFuncList;			//!< L[蓖
extern TStringList *FKeyLabelList;			//!< t@NVL[
extern TStringList *HotKeyList;				//!< zbgL[
extern TStringList *DirStack;				//!< fBNgX^bN
extern TStringList *PathMaskList;			//!< pX}XNXg
extern TStringList *RegDirList;				//!< o^fBNg
extern TStringList *ProtectDirList;			//!< 폜fBNg
extern TStringList *VirDriveList;			//!< zhCuXg
extern TStringList *ColorList;				//!< zF
extern TStringList *ExtColList;				//!< gqʔzF
extern TStringList *AssociateList;			//!< ֘At
extern TStringList *OpenStdCmdList;			//!< OpenStandard ̃R}h֘At
extern TStringList *EtcEditorList;			//!< ̑̃GfB^Xg
extern TStringList *ExtToolList;			//!< Oc[
extern TStringList *ExtMenuList;			//!< ǉj[
extern TStringList *CommandList;			//!< R}hXg
extern TStringList *CmdSetList;				//!< R}hꗗXg
extern TStringList *TaskCmdList;			//!< ^XNR}hXg
extern TStringList *DriveList;				//!< ωĎphCuXg
extern TStringList *NetDriveList;			//!< ݗLȃlbghCuXg
extern TStringList *AllDirHistory;			//!< Ŝ̃fBNg
extern TStringList *TextViewHistory;		//!< eLXg{
extern TStringList *TextEditHistory;		//!< eLXgҏW
extern TStringList *WorkListHistory;		//!< [NXg
extern TStringList *CopyPathHistory;		//!< Rs[pX̗
extern TStringList *InputDirHistory;		//!< fBNg̗͂
extern TStringList *InputCmdsHistory;		//!< R}h̗͂(t@C[)
extern TStringList *InputCmdsHistoryV;		//!< R}h̗͂(eLXgr[A)
extern TStringList *InputCmdsHistoryI;		//!< R}h̗͂(C[Wr[A)
extern TStringList *IncSeaHistory;			//!< CN^T[`̃L[[h
extern TStringList *FilterHistory;			//!< tB^̃L[[h
extern TStringList *WebSeaHistory;			//!< Web̗
extern TStringList *LatLngHistory;			//!< ܓxox̗
extern TStringList *HeadlineList;			//!< oXg (gq=K\p^[)
extern TStringList *ZoomRatioList;			//!< Y[{Xg
extern TStringList *InterpolationList;		//!< kEgASỸXg
extern TStringList *CnvCharList;			//!< ֎~^[U`ϊXg
extern TStringList *RenCmdFileList;			//!< R}ht@C̃Xg
extern TStringList *RenArcFileList;			//!< A[JCut@C̃Xg
extern TStringList *RedrawList;				//!< `}~pXg
extern TStringList *CmdRequestList;			//!< R}hvXg
extern TStringList *CommandHistory;			//!< R}h

extern UnicodeString LogBufStr;				//!< ^XÑOobt@ (LogRWLock ŕی삷邱)
extern TMultiReadExclusiveWriteSynchronizer *LogRWLock;

extern TListBox     *LogWndListBox;			//!< OEBhEpXg{bNX
extern TStringList  *LogBufList;			//!< OXg{bNX(z)pobt@
extern UsrScrollPanel *LogWndScrPanel;		//!< VvXN[o[

extern int  LayoutMode;			//!< ʃCAEg[h
extern bool DivFileListUD;		//!< t@CXg㉺ɕ
extern bool DivDirInfUD;		//!< fBNg㉺ɕ

extern TFont *ListFont;			//!< t@CXg
extern TFont *FileInfFont;		//!< t@C
extern TFont *TxtPrvFont;		//!< eLXgvr[
extern TFont *LogFont;			//!< O
extern TFont *ViewerFont;		//!< eLXgr[A
extern TFont *GrepResFont;		//!< GREPʃXg
extern TFont *DirInfFont;		//!< fBNg
extern TFont *DrvInfFont;		//!< hCu
extern TFont *LstHdrFont;		//!< ꗗ̃wb_
extern TFont *ViewHdrFont;		//!< r[Awb_
extern TFont *GenListFont;		//!< ꗗ_CAO
extern TFont *HintFont;			//!< qg
extern TFont *SttBarFont;		//!< Xe[^Xo[
extern TFont *CalcFont;			//!< d
extern TFont *ToolBarFont;		//!< c[o[
extern TFont *TabBarFont;		//!< ^uo[
extern TFont *CharInfFont;		//!< 
extern TStringList *FontList;	//!< J[

/** @defgroup GLOBAL_COLORS zF */
/** @{ */
/** @defgroup OPTION_COLORS IvVݒ */
/** @{ */
extern TColor col_bgList;		//!< ꗗ̔wiF
extern TColor col_bgList2;		//!< ꗗ̔wiF()
extern TColor col_fgList;		//!< ꗗ̕F
extern TColor col_Splitter;		//!< E
extern TColor col_bgArc;		//!< zfBNg̔wiF
extern TColor col_bgFind;		//!< ʃXg̔wiF
extern TColor col_bgWork;		//!< [NXg̔wiF
extern TColor col_bgFTP;		//!< FTP[g̔wiF
extern TColor col_bgADS;		//!< փf[^Xg[ꗗ̔wiF
extern TColor col_selItem;		//!< Iڂ̔wiF
extern TColor col_oppItem;		//!< ΃pXIڂ̔wiF
extern TColor col_fgSelItem;	//!< Iڂ̕F
extern TColor col_bgMark;		//!< x}[Nڂ̔wiF
extern TColor col_matchItem;	//!< INC.T[`̃}b`ڔwiF
extern TColor col_Differ;		//!< ʃXg̑ӏwiF
extern TColor col_DifferN;		//!< ʃXg̒ډӏwiF
extern TColor col_Cursor;		//!< CJ[\̐F
extern TColor col_bgScrBar;		//!< VvXN[o[̔wiF
extern TColor col_bgScrKnob;	//!< VvXN[mu̐F
extern TColor col_frScrKnob;	//!< VvXN[mu̗֊sF
extern TColor col_bgActKnob;	//!< hbÕVvXN[muF
extern TColor col_lnScrHit;		//!< VvXN[o[̃qbgsF
extern TColor col_lnScrSel;		//!< VvXN[o[̑IsF
extern TColor col_Folder;		//!< fBNg̕F
extern TColor col_SymLink;		//!< V{bNN/WNV̕F
extern TColor col_Protect;		//!< 폜fBNg̕F
extern TColor col_ReadOnly;		//!< ǂݍݐp̕F
extern TColor col_Compress;		//!< k̕F
extern TColor col_Hidden;		//!< B̕F
extern TColor col_System;		//!< VXe̕F
extern TColor col_fgSpace;		//!< 󔒋L̕F
extern TColor col_fgTagNam;		//!< ftHg̃^OF
extern TColor col_InvItem;		//!< ȍڂ̕F
extern TColor col_bgTabBar;		//!< ^uo[̔wiF
extern TColor col_bgActTab;		//!< ANeBuȃ^u̔wiF
extern TColor col_bgInAcTab;	//!< ANeBuȃ^u̔wiF
extern TColor col_frmTab;		//!< ^u̗֊sF
extern TColor col_fgTab;		//!< ^u̕F
extern TColor col_bgListHdr;	//!< Xgwb_̔wiF
extern TColor col_fgListHdr;	//!< Xgwb_̕F
extern TColor col_bgDirInf;		//!< fBNg̔wiF
extern TColor col_fgDirInf;		//!< fBNg̕F
extern TColor col_bgDirRel;		//!< fBNg֌W̔wiF
extern TColor col_fgDirRel;		//!< fBNg֌W̕F
extern TColor col_bdrDirB;		//!< fBNg̉E
extern TColor col_bgDrvInf;		//!< hCu̔wiF
extern TColor col_fgDrvInf;		//!< hCu̕F
extern TColor col_bdrDrvT;		//!< hCȕ㋫E
extern TColor col_bgInf;		//!< t@C̔wiF
extern TColor col_fgInf;		//!< t@C̕F
extern TColor col_fgInfNam;		//!< t@C̍ږF
extern TColor col_fgInfEmp;		//!< t@C̋F
extern TColor col_bgTxtPrv;		//!< eLXgvr[̔wiF
extern TColor col_fgTxtPrv;		//!< eLXgvr[̕F
extern TColor col_bgLog;		//!< O̔wiF
extern TColor col_fgLog;		//!< O̕F
extern TColor col_bgTask;		//!< ^XNԕ\̔wiF
extern TColor col_fgPrgBar;		//!< ^XNio[F
extern TColor col_bgPrgBar;		//!< ^XNiwiF
extern TColor col_Error;		//!< G[/ӂ̕F
extern TColor col_TlBorder;		//!< c[EChE̋E

extern TColor col_bgView;		//!< eLXgr[A̔wiF
extern TColor col_fgView;		//!< eLXgr[A̕F
extern TColor col_Margin;		//!< eLXgr[A̗]
extern TColor col_bgRuler;		//!< [̔wiF
extern TColor col_fgRuler;		//!< [̖ڐF
extern TColor col_bgLineNo;		//!< sԍwiF
extern TColor col_LineNo;		//!< sԍF
extern TColor col_Mark;			//!< s}[N
extern TColor col_bdrLine;		//!< sԍ̋E
extern TColor col_bdrFold;		//!< ܂ԂE
extern TColor col_bdrFixed;		//!< Œ蒷\̏cr
extern TColor col_Indent;		//!< CfgKCh
extern TColor col_Indent2;		//!< CfgKCh()
extern TColor col_Comment;		//!< Rg̕F
extern TColor col_Strings;		//!< ̕F
extern TColor col_Reserved;		//!< \̕F
extern TColor col_Symbol;		//!< V{̕F
extern TColor col_Numeric;		//!< l̕F
extern TColor col_fgEmpBin1;	//!< oCiF1
extern TColor col_fgEmpBin2;	//!< oCiF2
extern TColor col_fgEmpBin3;	//!< oCiF3
extern TColor col_Headline;		//!< o̕F
extern TColor col_URL;			//!< URL̕F
extern TColor col_LocalLink;	//!< [Jt@Cւ̃N
extern TColor col_bgImage;		//!< 摜̔wiF
extern TColor col_bgDblPg;		//!< J\̗]F
extern TColor col_bgWMF;		//!< ^t@C̔wiF
extern TColor col_bgTips;		//!< c[`bv̔wiF
extern TColor col_fgTips;		//!< c[`bv̕F
extern TColor col_bgHint;		//!< qg\̔wiF
extern TColor col_fgHint;		//!< qg\̕F
extern TColor col_bgWarn;		//!< x\̔wiF
extern TColor col_fgEmp;		//!< F
extern TColor col_bgEmp;		//!< wiF
extern TColor col_Ruby;			//!< r
extern TColor col_TAB;			//!< ^u\F
extern TColor col_CR;			//!< s\F
extern TColor col_HR;			//!< r̐F
extern TColor col_Ctrl;			//!< Rg[R[h
extern TColor col_fgPair;		//!< Ή銇ʂ̕F

extern TColor col_bdrThumb;		//!< TlC̋E
extern TColor col_ThumbExif;	//!< TlCEixf
extern TColor col_ImgGrid;		//!< 摜Obh
extern TColor col_OptFind;		//!< IvVݒ̌
extern TColor col_Tim1H;		//!< 1Ԉȓ̃^CX^vF
extern TColor col_Tim3H;		//!< 3Ԉȓ́`
extern TColor col_Tim6H;		//!< 6Ԉȓ́`
extern TColor col_Tim1D;		//!< 1ȓ́`
extern TColor col_Tim3D;		//!< 3ȓ́`
extern TColor col_Tim7D;		//!< 7ȓ́`
extern TColor col_Tim1M;		//!< 1ȓ́`
extern TColor col_Tim3M;		//!< 3ȓ́`
extern TColor col_Tim6M;		//!< 6ȓ́`
extern TColor col_Tim1Y;		//!< 1Nȓ́`
extern TColor col_Tim3Y;		//!< 3Nȓ́`
extern TColor col_TimOld;		//!< Ó`
extern TColor col_Size4G;		//!< 4GBȏ
extern TColor col_Size2G;		//!< 2GBȏ
extern TColor col_Size1G;		//!< 1GBȏ
extern TColor col_Size512M;		//!< 512MBȏ
extern TColor col_Size256M;		//!< 256MBȏ
extern TColor col_Size128M;		//!< 128MBȏ
extern TColor col_Size64M;		//!< 64MBȏ
extern TColor col_Size32M;		//!< 32MBȏ
extern TColor col_Size16M;		//!< 16MBȏ
extern TColor col_Size1M;		//!< 1MBȏ
extern TColor col_Size1K;		//!< 1KBȏ
extern TColor col_SizeLT;		//!< 1KB
extern TColor col_Size0;		//!< 0

extern TColor col_GrBack;		//!< Ot̔wiF
extern TColor col_GrLine;		//!< Ot̃C
extern TColor col_GrGrid;		//!< Ot̃Obh
extern TColor col_GrText;		//!< Ot̕F

extern TColor col_GitHEAD;		//!< Gitr[A : wbh
extern TColor col_GitMark;		//!<   Ot}[N
extern TColor col_GitBra;		//!<   u`
extern TColor col_GitBraR;		//!<   [gu`
extern TColor col_GitTag;		//!<   ^O
extern TColor col_GitHash;		//!<   nbV
extern TColor col_GitIns;		//!<   - s
extern TColor col_GitDel;		//!<   + s

extern TColor col_bgTlBar1;		//!< c[o[̃Of[VJnF
extern TColor col_bgTlBar2;		//!< c[o[̃Of[VIF
extern TColor col_fgTlBar;		//!< c[o[̕F
extern TColor col_htTlBar;		//!< c[o[̃zbggbLOF
extern TColor col_bgInfHdr;		//!< wb_̔wiF
extern TColor col_fgInfHdr;		//!< wb_̕F

extern TColor col_bgChInf;		//!< Tv̔wiF
extern TColor col_fgChInf;		//!< Tv̕F
extern TColor col_bgEdBox;		//!< Edit {bNX̔wiF
extern TColor col_fgEdBox;		//!< Edit {bNX̕F
/** @} */
/** @} */

extern UnicodeString BgImgName[MAX_BGIMAGE];		//!< wi摜t@C
extern Graphics::TBitmap *BgImgBuff[MAX_BGIMAGE];	//!< wi摜obt@

extern int  BgImgMode;			//!< wi摜\[h
extern int  BgImgSubMode;
extern int  BgColAlpha;			//!< wiFAt@
extern bool BgImgGray;			//!< O[XP[
extern bool BgImgHideScr;		//!< XN[ɉB
extern int  BgHideTime;			//!< A
extern bool BgImgTileIf;		//!< wTCYȉȂׂĕ\
extern int  BgTileSize;

extern bool AlphaForm;			//!< Cʂ𓧖
extern int  AlphaValue;			//!< CʃAt@

extern UnicodeString FontSampleTxt;		//!< tHg̃Tv\
extern UnicodeString FontSampleSym;		//!< tHg̃Tv\V{
extern int FontSampleSize;				//!< \TCY
extern TColor FontSampleFgCol;			//!< F
extern TColor FontSampleBgCol;			//!< wiF
extern TColor FontSampleGridCol;		//!< F
extern bool   FontSampleShowGrid;		//!< \

extern UnicodeString TextEditor;		//!< eLXgGfB^
extern UnicodeString TextEditorFrmt;	//!< p[^(Grepp)
extern UnicodeString TextEditorFrmt2;	//!< p[^(t@[p)

extern UnicodeString ImageEditor;		//!< C[WGfB^
extern UnicodeString FExtImgEidt;		//!< C[WGfB^̑Ήgq
extern bool ImageEditSgl;				//!< C[WGfB^t@CɌʋN

extern UnicodeString FExtViewTab4;		//!< ^u4̊gq
extern UnicodeString FExtViewTabX;		//!< CӃ^ůgq
extern int  ViewTabWidthX;				//!< CӃ^u

extern UnicodeString BinaryEditor;		//!< oCiGfB^
extern UnicodeString SoundTaskFin;		//!< ^XNI̒ʒm
extern UnicodeString SoundFindFin;		//!< I̒ʒm
extern UnicodeString SoundWarning;		//!< x
extern UnicodeString SoundWatch;		//!< t@CĎ

extern int  FlashCntWarning;			//!< x̓_ŉ
extern int  FlashTimeWarning;			//!< x̓_ŊԊu
extern int  FlashCntTaskfin;			//!< ^XNI̓_ŉ
extern int  FlashTimeTaskfin;			//!< ^XNI̓_ŊԊu

extern int  MaxLogLines;				//!< O̍ős
extern int  MsgHintTime;				//!< qg̕\
extern int  KeyHintTime;				//!< 2Xg[Nqg̑ҋ@
extern int  NotifyTaskTime;				//!< `bȏォ^XN̏Iɖ炷
extern int  CmpDelOwCnt;				//!< S폜̏㏑
extern int  ViewTxtInterLn;				//!< r[A̍s
extern int  ViewLeftMargin;				//!< r[A̍]
extern int  ViewFoldWidth;				//!< ܂Ԃ(pP)
extern bool ViewFoldFitWin;				//!< ܂ԂEBhEɍ킹
extern bool TvCursorVisible;			//!< r[AŃJ[\ɉ̈
extern bool LimitBinCsr;				//!< oCi\ŃJ[\ړ𐧌
extern bool TxtColorHint;				//!< J[\ʒul̃J[qg\
extern bool AltBackSlash;				//!< \  _(U+2216)ŕ\
extern bool FormatJson;					//!< .json t@C𐮌`
extern bool DecodeDfmStr;				//!< .dfm t@C̕fR[h
extern bool BinMemMaped;				//!< oCił̓}bvht@CƂĊJ
extern int  ViewFixedLimit;				//!< Œ蒷\̍ő啝
extern int  ViewTxtLimitSize;			//!< eLXg̍őǍTCY
extern int  ViewBinLimitSize;			//!< oCi̍őǍ(or }bv)TCY
extern int  ListWheelScrLn;				//!< zC[ɂXN[s(Xg)
extern int  ViewWheelScrLn;				//!< zC[ɂXN[s(r[A)
extern int  PlaySndLimitTime;			//!< TEhĐ^C
extern bool ShowTextPreview;			//!< eLXgvr[\
extern int  PrvTxtInfLn;				//!< eLXgvr[̍s
extern bool ShowTailPreview;			//!< vr[\
extern int  PrvTxtTailLn;				//!< vr[s
extern int  PrvActTailLn;				//!< vr[Lɂs
extern int  WatchInterval;				//!< fBNgĎԊu
extern int  InfPrvWait;					//!< 擾/vr[̒x
extern int  LogInterval;				//!< O̍XVԊu
extern int  ListInterLn;				//!< t@CXg̍s
extern int  CursorWidth;				//!< J[\̕
extern int  CursorAlpha;				//!< J[\swiAt@
extern int  CellAlpha;					//!< Z̔wiAt@
extern int  SplitterWidth;				//!< E̕
extern int  SplitterWidth2;
extern int  FExtMaxWidth;				//!< gq̍ő啶
extern int  SizeFormatMode;
extern int  SizeDecDigits;				//!< TCY\ɂ鏬_ȉ̌
extern int  ListPercent;				//!< t@CXg̔䗦
extern int  ImgFrameMargin;				//!< tBbg\̗]
extern int  ImgFitMaxZoom;				//!< tBbg\̋e{
extern int  ImgGridHorzN;				//!< Obh̉
extern int  ImgGridVertN;				//!< Obh̏c
extern int  MinShowTime;				//!< ŏ\^C
extern int  ThumbnailSize;				//!< TlC̃TCY
extern int  ThumbBdrWidth;				//!< TlC̋E
extern int  ThumbScaleOpt;				//!< TlC̏kASY
extern int  ThumbnailPos;				//!< TlC̕\ʒu
extern int  ImgDblMargin;				//!< JԊu

extern bool ShowImgSidebar;				//!< TCho[\
extern bool ImgSidebarIsLeft;			//!< TCho[͍

extern bool HasCallHotkey;				//!< ĂяozbgL[邩H

extern bool HideSizeTime;				//!< TCYƍXVB

//---------------------------------------------------------------------------
/** @addtogroup FILELIST */
/** @{ */

/**
 * @brief t@CXg
 */
struct file_rec {
	UnicodeString f_name;		//!< pXtt@C
	UnicodeString p_name;		//!< pX
	UnicodeString n_name;		//!< pXt@C
	UnicodeString b_name;		//!< t@C啔
	UnicodeString f_ext;		//!< gq
	UnicodeString attr_str;		//!< 
	UnicodeString alias;		//!< GCAX
	UnicodeString arc_name;		//!< A[JCu
	UnicodeString tmp_name;		//!< ꎞ𓀖
	UnicodeString r_name;		//!< \
	UnicodeString l_name;		//!< N
	UnicodeString tags;			//!< ^O
	UnicodeString hash;			//!< nbV/ 摜nbV(ގ\[g)
	UnicodeString vctr;			//!< 摜:xNg(ގ\[g)
	UnicodeString memo;			//!< x}[Nꗗ:   (e \t ݒ)@n
								//!< |Wgꗗ: (R~bg \t )

	int  tag;					//!< 0: / 1: E
	bool is_up;					//!< ..
	bool is_dir;				//!< fBNg
	bool is_sym;				//!< p[X|Cg
	bool is_jct;				//!< WNV
	bool is_virtual;			//!< zfBNg̃t@C
	bool is_ftp;				//!< FTP
	bool is_ads;				//!< փf[^Xg[
	bool is_dummy;				//!< _~[(̃hCuA[NXg̃Zp[^Arʂ̕sݍڂȂ)
	bool selected;				//!< I
	bool failed;				//!< t@C[: ꎞ𓀎s/  C[Wr[A: Ǎs

	__int64 f_size;				//!< TCY
	__int64 o_size;				//!< fBXN̐LTCY
	__int64 c_size;				//!< kTCY

	int  f_attr;				//!< 
	TDateTime f_time;			//!< ^CX^v
	int  f_count;				//!< t@C
	int  d_count;				//!< fBNg
	int  img_ori;				//!< 摜
	int  distance;				//!< ҏW\[gl
	bool is_video;				//!< 

	int  base_end_x;			//!< t@C啔̖ʒu(`掞ɐݒA}EXIŗp)
	bool matched;				//!< CN^Ń}b`

	TStringList *inf_list;		//!< 񃊃Xg
	UnicodeString prv_text;		//!< eLXgvr[
	UnicodeString tail_text;	//!< eLXgvr[()
	int  code_page;				//!< R[hy[W
};

//---------------------------------------------------------------------------
/**
 * @brief t@CXg̏
 */
struct flist_stt {
	UnicodeString vol_name;		//!< {[
	__int64 drive_Used;			//!< hCugpe
	__int64 drive_Free;			//!< hCu󂫗e
	__int64 drive_Total;		//!< hCuS̗e
	__int64 cur_total;			//!< Jg̍vTCY
	__int64 occ_total;			//!< Jg̐LTCY
	__int64 cmp_total;			//!< Jg̈kTCY
	int clu_size;				//!< NX^TCY

	int f_cnt;					//!< t@C
	int d_cnt;					//!< fBNg
	int f_cnt_total;
	int d_cnt_total;
	int sel_f_cnt;				//!< It@C
	int sel_d_cnt;				//!< IfBNg
	__int64 sel_size;			//!< ITCY

	int last_fl_idx;			//!< t@CXgɕAƂ̃J[\ʒu

	bool show_f_d_cnt;			//!< t@CAfBNg\
	bool dir_graph;				//!< fBNgeʂOt\(΃Jg)
	bool dsk_graph;				//!< fBNgeʂOt\(΃hCu)
	bool sub_counted;			//!< TufBNgׂăJEgς

	int lwd_half;				//!< "X" ̕
	int lwd_fext_max;			//!< ".WWWWWWWWWWWW" ̕
	int lwd_fext;				//!< gq̕\
	int lwd_size;				//!< TCY̕\
	int lwd_time;				//!< ^CX^v̕\
	int lwd_path;				//!< ꏊ̕\(Xg)

	int lxp_fext;				//!< gq̕\ʒu
	int lxp_size;				//!< TCY̕\ʒu
	int lxp_time;				//!< ^CX^v̕\ʒu
	int lxp_path;				//!< ꏊ̕\ʒu
	int lxp_right;				//!< [ʒu

	TColor color_bgDirInf;		//!< .NyanFi ɂʐF
	TColor color_fgDirInf;
	TColor color_bgDrvInf;
	TColor color_fgDrvInf;
	TColor color_Cursor;
	TColor color_selItem;

	bool is_TabFixed;			//!< ^uύXɑ΂ăpXŒ

	bool git_checked;			//!< [..]Git擾

	bool is_Work;				//!< [NXg
	bool is_FTP;				//!< FTP[g

	bool is_Arc;				//!< zfBNg
	UnicodeString arc_DspPath;	//!< A[JCu̕\pX
	UnicodeString arc_SubPath;	//!< A[JCuȉ̃TufBNg
	UnicodeString arc_Name;		//!< A[JCut@C(temp)
	TStringList  *arc_RetList;	//!< dA[JCup̖߂胊Xg
	TStringList  *arc_TmpList;	//!< ꎞ𓀃fBNgXg

	bool is_ADS;				//!< փf[^Xg[
	UnicodeString ads_Name;		//!< CXg[̃t@C

	UnicodeString LibraryInfo;	//!< Cut@C \t pX
	UnicodeString LibSubPath;

	bool is_Find;				//!< ʃXg
	bool is_narrow;				//!< i荞
	bool find_Loaded;			//!< t@Cǂݍ񂾃Xg
	bool find_UseSet;			//!< ݒt@Cgp
	int  find_SortMode;			//!< ݒt@Cɂ\[g[hݒ

	bool find_Dir;				//!< fBNg
	bool find_Both;				//!< t@CEfBNg
	bool find_SubDir;			//!< TufBNg
	bool find_Arc;				//!< A[JCu
	bool find_xTrash;			//!< ݔ͌Ȃ

	bool find_MARK;				//!< }[N
	bool find_TAG;				//!< ^O
	bool find_TAG_all;			//!< ׂẴ^OɃ}b`
	bool find_DICON;			//!< tH_ACR
	bool find_DUPL;				//!< dt@Č
	bool find_HLINK;			//!< n[hN

	bool find_RegEx;			//!< K\
	bool find_And;				//!< AND
	bool find_Case;				//!< 召

	bool find_Warn;				//!< D܂Ȃt@C
	bool find_hasAds;			//!< փf[^Xg[
	bool find_useProc;			//!< ʃvZXgp

	bool find_ResLink;			//!< ʃXg甽Α֔f
	bool find_DirLink;			//!< fBNg𔽉f
	bool find_PathSort;			//!< ꏊŃ\[g

	UnicodeString find_Path;	//!< pX
	UnicodeString find_DirList;	//!< fBNgEXg
	UnicodeString find_SkipDir;	//!< OfBNg(;؂)
	UnicodeString find_Name;	//!< (n[hNp)
	UnicodeString find_Mask;	//!< }XN
	UnicodeString find_Keywd;	//!< L[[h
	UnicodeString find_Tags;	//!< ^O
	UnicodeString find_Icons;	//!< tH_ACR(s؂)

	TStringList  *find_SubList;	//!< ITufBNg

	int  find_DT_mode;			//!< t
	TDateTime find_DT_value;
	UnicodeString find_DT_str;
	int  find_DT_rel;			//!< Ύwl

	int  find_SZ_mode;			//!< TCY
	__int64 find_SZ_value;
	int  find_CT_mode;			//!< e
	int  find_AT_mode;			//!< 
	int  find_AT_value;

	int  find_TM_mode;			//!< ^C
	TTime find_TM_value;

	int  find_codepage;			//!< R[hy[W
	UnicodeString find_LineBrk;	//!< sR[h
	int  find_BOM_mode;			//!< BOM

	int  find_RT_mode;			//!< Cg
	int  find_RT_value;
	int  find_FS_mode;			//!< t[
	int  find_FS_value;
	int  find_FW_mode;			//!< t[
	int  find_FW_value;
	int  find_FH_mode;			//!< t[
	int  find_FH_value;

	int  find_IW_mode;			//!< 摜TCY
	unsigned int find_IW_value;
	int  find_IH_mode;
	unsigned int find_IH_value;
	bool find_IWH_max;

	int  find_SR_mode;			//!< TvO[g
	int  find_SR_value;
	int  find_BT_mode;			//!< rbg
	int  find_CH_mode;			//!< `l

	int  find_IC_mode;			//!< ACR
	int  find_IC_value;

	int  find_HL_mode;			//!< NJEg
	int  find_HL_value;

	UnicodeString find_PrpKwd;
	bool find_PrpRegEx;
	bool find_PrpAnd;
	bool find_PrpCase;

	UnicodeString find_TxtKwd;
	bool find_TxtRegEx;
	bool find_TxtAnd;
	bool find_TxtCase;

	UnicodeString find_ExifKwd;
	bool find_ExifRegEx;
	bool find_ExifAnd;
	bool find_ExifCase;

	UnicodeString find_LatLng;
	double find_GpsLat;
	double find_GpsLng;
	int    find_GpsRange;

	bool is_IncSea;				//!< CN^T[`
	bool is_Migemo;				//!< Migemo[h
	bool is_Filter;				//!< tB^[h
	bool is_Fuzzy;				//!< ܂[h
	bool filter_csns;			//!< tB^ő召

	UnicodeString incsea_Word;
	UnicodeString incsea_Ptn;
};

extern flist_stt ListStt[MAX_FILELIST];
extern flist_stt *CurStt;
extern flist_stt *OppStt;
/** @} */

//---------------------------------------------------------------------------
//hCu
//---------------------------------------------------------------------------
/**
 * @brief hCu
 */
struct drive_info {
	UnicodeString drive_str;
	bool		  accessible;
	bool		  ejectable;
	bool		  is_virtual;
	int			  drv_type;
	UnicodeString type_str;		//!< 
	UnicodeString volume;		//!< {[
	UnicodeString unc;			//!< lbg[NhCuUNCpX
	UnicodeString mnt_dir;		//!< zhCũ}EgpX
	UnicodeString f_system;		//!< t@CVXe
	UnicodeString bus_type;		//!< ڑI/F
	UnicodeString label;		//!< \px
	bool		  is_NTFS;
	bool		  is_SSD;
	bool		  is_RAM;
	TIcon		  *small_ico;
	TIcon		  *large_ico;
};

//---------------------------------------------------------------------------
/**
 * @brief ^u
 */
struct tab_info {
	TRect rc;	//`̈
	TStringList *sel_list[MAX_FILELIST];	//!< I
	TStringList *dir_hist[MAX_FILELIST];	//!< fBNg
	int			 dir_hist_p[MAX_FILELIST];	//!< ʒu
	int			 sort_mode[MAX_FILELIST];	//!< \[g[h
	bool		 sync_lr;					//!< Kw
};

//---------------------------------------------------------------------------
//R}ht@CXg
//---------------------------------------------------------------------------
struct cmdf_rec {
	TDateTime   f_time;				//!< ^CX^v
	TStringList *file_buf;			//!< t@Ce
	TStringList *cmd_list;			//!< R}hXg
	int exe_count;					//!< s
	bool noreload;					//!< ēǂݍ݂Ȃ
};
extern TStringList *CmdFileList;	//!< R}ht@C̃Xg
extern TStringList *XCMD_VarList;	//!< ϐXg

//---------------------------------------------------------------------------
inline void InvalidateFileList(int tag = CurListTag)
{
	FileListBox[tag]->Invalidate();
}

//---------------------------------------------------------------------------
/** @brief VCLX^CgpĂ邩H */
inline bool use_VclStyle()
{
	return !SameText(TStyleManager::ActiveStyle->Name, "Windows");
}

//---------------------------------------------------------------------------
inline TColor get_ListBgCol()
{
	return (col_bgList==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgList;
}
inline TColor get_ListFgCol()
{
	return (col_fgList==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindowText) : col_fgList;
}
inline TColor get_AltBgCol(int idx)
{
	return (col_bgList2!=col_None && idx%2==1)? col_bgList2 : get_ListBgCol();
}
//---------------------------------------------------------------------------
inline TColor get_ViewBgCol()
{
	return (col_bgView==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgView;
}
inline TColor get_ViewFgCol()
{
	return (col_bgView==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindowText) : col_fgView;
}
//---------------------------------------------------------------------------
inline TColor get_TxtPrvBgCol()
{
	return (col_bgTxtPrv==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgTxtPrv;
}
inline TColor get_TxtPrvFgCol()
{
	return (col_fgTxtPrv==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindowText) : col_fgTxtPrv;
}
//---------------------------------------------------------------------------
inline TColor get_InfBgCol()
{
	return (col_bgInf==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgInf;
}
inline TColor get_InfFgCol()
{
	return (col_fgInf==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindowText) : col_fgInf;
}
//---------------------------------------------------------------------------
inline TColor get_LogBgCol()
{
	return (col_bgLog==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgLog;
}
inline TColor get_LogFgCol()
{
	return (col_fgLog==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindowText) : col_fgLog;
}
inline TColor get_TaskBgCol()
{
	return (col_bgTask==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clWindow) : col_bgTask;
}
//---------------------------------------------------------------------------
inline TColor get_ActTabBgCol()
{
	return (col_bgActTab==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_bgActTab;
}
inline TColor get_InAcTabBgCol()
{
	return (col_bgInAcTab==col_None)?
		AdjustColor(TStyleManager::ActiveStyle->GetSystemColor(clBtnFace), ADJCOL_BGBIT) : col_bgInAcTab;
}
inline TColor get_TabFgCol()
{
	return (col_fgTab==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgTab;
}
inline TColor get_TabFrmCol()
{
	return (col_frmTab==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnShadow): col_frmTab;
}
inline TColor get_TabBarBgCol()
{
	return (col_bgTabBar==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_bgTabBar;
}
//---------------------------------------------------------------------------
inline TColor get_ListHdrBgCol()
{
	return (col_bgListHdr==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_bgListHdr;
}
inline TColor get_ListHdrFgCol()
{
	return (col_fgListHdr==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgListHdr;
}
//---------------------------------------------------------------------------
inline TColor get_InfHdrBgCol()
{
	return (col_bgInfHdr==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_bgInfHdr;
}
inline TColor get_InfHdrFgCol()
{
	return (col_fgInfHdr==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgInfHdr;
}
//---------------------------------------------------------------------------
inline TColor get_DirInfBgCol()
{
	return ((col_bgDirInf==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_bgDirInf);
}
inline TColor get_DirInfFgCol()
{
	return ((col_fgDirInf==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgDirInf);
}
//---------------------------------------------------------------------------
inline TColor get_DirRelBgCol()
{
	return ((col_bgDirRel==col_None)?
				AdjustColor(TStyleManager::ActiveStyle->GetSystemColor(clBtnFace), ADJCOL_BGBIT) : col_bgDirRel);
}
inline TColor get_DirRelFgCol()
{
	return ((col_fgDirRel==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgDirRel);
}
//---------------------------------------------------------------------------
inline TColor get_DrvInfBgCol()
{
	return ((col_bgDrvInf==col_None)?
				AdjustColor(TStyleManager::ActiveStyle->GetSystemColor(clBtnFace), ADJCOL_BGBIT) : col_bgDrvInf);
}
inline TColor get_DrvInfFgCol()
{
	return ((col_fgDrvInf==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnText) : col_fgDrvInf);
}
//---------------------------------------------------------------------------
inline TColor get_SplitterCol()
{
	return (col_Splitter==col_None)? TStyleManager::ActiveStyle->GetSystemColor(clBtnFace) : col_Splitter;
}

//---------------------------------------------------------------------------
inline bool is_SelFgCol(TOwnerDrawState stt)
{
	return (stt.Contains(odSelected) && col_fgSelItem!=col_None);
}
inline bool is_SelFgCol(TGridDrawState stt)
{
	return (stt.Contains(gdSelected) && col_fgSelItem!=col_None);
}
inline bool is_SelFgCol(bool sel)
{
	return (sel && col_fgSelItem!=col_None);
}

//---------------------------------------------------------------------------
inline TColor GetActiveCol(TColor col)
{
	return ((InactiveGray && (!Application->Active || !Application->MainForm->Active))?
											AdjustColor(GrayCol(col), InactiveAdjust) : col);
}

//---------------------------------------------------------------------------
inline UnicodeString get_FExtMaxStr(int n = 0)
{
	return ("." + StringOfChar(_T('W'), (n>0)? n : FExtMaxWidth));
}

inline UnicodeString get_SearchStr(UnicodeString s, SearchOption opt)
{
	return (opt.Contains(soCSV)? get_csv_item(s, 0) : (opt.Contains(soTree) || opt.Contains(soTSV))? get_pre_tab(s) : s);
}

inline bool is_SearchMatch(UnicodeString s, UnicodeString ptn, SearchOption opt)
{
	TRegExOptions x_opt;
	if (!opt.Contains(soCaseSens)) x_opt << roIgnoreCase;

	return (opt.Contains(soMigemo)? TRegEx::IsMatch(s, ptn, x_opt) :
		  opt.Contains(soCaseSens)? ContainsStr(s, ptn) : ContainsText(s, ptn));
}

//---------------------------------------------------------------------------
//\[g[h
inline int CurSortMode()
{
	return (CurStt->is_Find && CurStt->find_PathSort)? 6 : SortMode[CurListTag];
}

inline int TagSortMode(int tag)
{
	return (ListStt[tag].is_Find && ListStt[tag].find_PathSort)? 6 : SortMode[tag];
}

//---------------------------------------------------------------------------
int __fastcall CompLogical(UnicodeString s0, UnicodeString s1, bool natural_sw);
int __fastcall CompNameFN(UnicodeString s0, UnicodeString s1);
int __fastcall CompNameLN(UnicodeString s0, UnicodeString s1);

int __fastcall CompDirName(file_rec *fp0, file_rec *fp1);
int __fastcall CompDirTime(file_rec *fp0, file_rec *fp1);
int __fastcall CompDirSize(file_rec *fp0, file_rec *fp1);
int __fastcall CompDirAttr(file_rec *fp0, file_rec *fp1);
int __fastcall CompDirIcon(file_rec *fp0, file_rec *fp1);

int __fastcall SortComp_Name(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Ext( TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Time(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Size(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Attr(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_DirOnly(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_PathName(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Tags(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Memo(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_MarkTime(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_Distance(TStringList *List, int Index1, int Index2);
int __fastcall SortComp_GitStt(TStringList *List, int Index1, int Index2);

int __fastcall Comp_PathTree(TStringList *List, int Index1, int Index2);

int __fastcall KeyComp_Key(TStringList *List, int Index1, int Index2);
int __fastcall KeyComp_Cmd(TStringList *List, int Index1, int Index2);
int __fastcall KeyComp_Dsc(TStringList *List, int Index1, int Index2);

//---------------------------------------------------------------------------
UnicodeString yen_to_delimiter(UnicodeString s);
UnicodeString alt_yen_to(UnicodeString s);
UnicodeString get_MiniPathName(UnicodeString pnam, int max_w, TFont *font, bool rep_delimiter = true);

int get_EtcEditorFiles(TStringList *lst);
int get_ExtToolFiles(TStringList *lst);

UnicodeString get_dotNaynfi(UnicodeString dnam = EmptyStr);
UnicodeString get_dotNaynfi(UnicodeString dnam, bool inherit, bool force = false);

bool is_NewerTime(TDateTime scr_t, TDateTime dst_t);

bool check_if_unc(UnicodeString pnam);

bool load_NyanFiDef(UnicodeString fnam, TStringList *lst);
bool save_NyanFiDef(UnicodeString fnam, TStringList *lst);
UnicodeString read_NyanFiDef(UnicodeString fnam, UnicodeString key);
bool write_NyanFiDef(UnicodeString fnam, UnicodeString key, UnicodeString v);

UnicodeString get_cmdfile(UnicodeString s);
UnicodeString get_cmds_prm_file(UnicodeString prm);

UnicodeString make_ResponseFile(TStringList *lst, int arc_t, UnicodeString *files = NULL, bool excl = false);
UnicodeString make_ResponseFile(UnicodeString fnam, int arc_t);

UnicodeString format_CloneName(UnicodeString fmt, UnicodeString fnam, UnicodeString dst_dir, bool is_dir = false,
	TDateTime *ts = NULL, TStringList *lst = NULL);

UnicodeString format_FileName(UnicodeString fmt, UnicodeString fnam, UnicodeString *al_str = NULL);

TStringList *CreStringList(int obj_type = 0);

UnicodeString get_SrcHdrName(UnicodeString fnam);
UnicodeString get_NextSameName(UnicodeString fnam, bool only_text = false);
UnicodeString get_NextSameName(TStringList *lst, int idx, bool only_text = false);

void get_LibraryList(UnicodeString fnam, TStringList *lst, bool get_info = false);
UnicodeString get_LibFile_if_root();

UnicodeString get_SyncDirList(UnicodeString dnam, TStringList *lst, bool del_sw = false, bool syn_sw = true);
bool has_SyncDir(UnicodeString dnam, bool del_sw = false);
UnicodeString is_SyncDir(UnicodeString dnam1, UnicodeString dnam2);

void SetTempPathA(UnicodeString dnam);
void ClearTempDir(UnicodeString dnam = EmptyStr);
void ClearTempArc(UnicodeString dnam = EmptyStr);
void ClearTempArcList(int tag);

UnicodeString UpdateTempArcList(int tag = -1);
bool SetTmpFile(file_rec *fp, bool not_unpk = false, bool show_prg = false);
UnicodeString ExtractInZipImg(UnicodeString arc_file, UnicodeString img_fext);

void add_PackItem(file_rec *fp, int arc_t, UnicodeString src_dir, TStringList *lst);

bool is_InvalidUnc(UnicodeString dnam, bool del_sw = false);
UnicodeString CheckAvailablePath(UnicodeString dnam, int tag, bool prvnt_unc = false);

TStringList *GetCurBtnList(int scr_mode = ScrMode);

/** @addtogroup FILELIST */
/** @{ */

/**
 * @brief t@CXg擾
 * @param tag
 * @return TStringList*
 */
TStringList* GetFileList(int tag);

/**
 * @brief Jg̃Xg擾
 * @param only_filer t@C[݂̂Ώ
 * @return TStringList*
 */
TStringList* GetCurList(bool only_filer = false);

/**
 * @brief Α̃Xg擾
 * @return TStringList*
 */
TStringList* GetOppList();

/**
 * @brief IL?
 * @param lst ΏۃXg
 * @return true
 * @return false
 */
bool ListSelected(TStringList *lst);

/**
 * @brief I𒆂̍ڐ擾
 * @param lst ΏۃXg
 * @return int I𒆂̍ڐ
 */
int GetSelCount(TStringList *lst);

/**
 * @brief I𒆍ږXg擾
 * @param lst ΏۃXg
 * @param[out] sel_lst IڃXg
 * @param with_path pXtŎ擾
 * @param with_obj Objects 擾
 */
void GetSelList(TStringList *lst, TStringList *sel_lst, bool with_path = true, bool with_obj = false);

/**
 * @brief IԂ
 * @param lst ΏۃXg
 */
void ClrSelect(TStringList *lst = NULL);

/**
 * @brief }b`ڐ擾
 * @param lst ΏۃXg
 * @return int }b`ڐ
 */
int  GetMatchCount(TStringList *lst);

/**
 * @brief t@CXg̃\[g
 * @param lst ΏۃXg
 * @param tag
 */
void SortList(TStringList *lst, int tag = CurListTag);

/**
 * @brief t@CXgōڂ
 * @param fnam t@C
 * @param tag
 * @param top_idx 擪CfbNX
 * @return int CfbNX(Ȃꍇ -1)
 */
int  IndexOfFileList(UnicodeString fnam, int tag = CurListTag, int top_idx = -1);

file_rec* ExistsInList(UnicodeString fnam, TStringList *lst);

UnicodeString GetSelFileStr(TStringList *lst, bool use_tmp = false, bool inc_dir = false, TStringList *s_lst = NULL);

/**
 * @brief file_rec 쐬ď
 * @details file_rec 쐬ď܂Bcopy_fp w肷ƁA̓eRs[܂B
 * @param copy_fp
 * @return file_rec*
 */
file_rec* cre_new_file_rec(file_rec *copy_fp = NULL);

/**
 * @brief t@C file_rec 쐬
 * @param fnam t@C( \ ̏ꍇ̓fBNg)
 * @param tag
 * @param force ݂ȂꍇIɐݒ
 * @return file_rec*
 */
file_rec* cre_new_file_rec(UnicodeString fnam, int tag = -1, bool force = false);

/**
 * @brief [..] file_rec 쐬
 * @param tag
 * @return file_rec*
 */
file_rec* cre_new_up_rec(int tag);

/**
 * @brief file_rec ̃Rs[
 * @param s_fp Rs[
 * @param d_fp Rs[
 */
void copy_file_rec(file_rec *s_fp, file_rec *d_fp);

/**
 * @brief file_rec ̍폜
 * @param fp 폜Ώ
 */
void del_file_rec(file_rec *fp);

void inv_file_rec(file_rec *fp);

/**
 * @brief ڂ͑I\H
 * @param fp Ώۍ
 * @return true
 * @return false
 */
bool is_selectable(file_rec *fp);

/**
 * @brief I\ȍڂ̑IԂݒ
 * @param fp Ώۍ
 * @param sw I
 * @return true
 * @return false
 */
bool set_select(file_rec *fp, bool sw = true);

/**
 * @brief I\ȍڂ̑IԂ𔽓]
 * @param fp Ώۍ
 * @return true
 * @return false
 */
bool set_select_r(file_rec *fp);

/**
 * @brief t@CXg̃NA
 * @param lst ΏۃXg
 */
void clear_FileList(TStringList *lst);

/**
 * @brief t@CXg̍ڍ폜
 * @param lst ΏۃXg
 * @param idx 폜CfbNX
 */
void del_FileListItem(TStringList *lst, int idx);

/**
 * @brief t@CXg̓eւ
 * @param lst1 Xg1
 * @param lst2 Xg2
 * @param swap_tag ^Oւ
 */
void swap_FileList(TStringList *lst1, TStringList *lst2, bool swap_tag = true);
/** @} */

tab_info* cre_tab_info(bool sync_lr = false);
int  add_TabList(UnicodeString item);
void insert_TabList(int idx, UnicodeString item);
void del_tab_info(tab_info *tp);
tab_info *get_TabInfo(int tab_idx = -1);
TStringList *get_DirHistory(int tab_idx = -1, int tag = CurListTag);
int  *get_DirHistPtr(int tab_idx = -1, int tag = CurListTag);
void clear_DirHistory(int tab_idx = -1, int tag = CurListTag);
UnicodeString get_TabWorkList(int tab_idx);
void save_DirHistory(UsrIniFile *ini_file);
bool save_TagGroup(UnicodeString fnam);

/**
 * @brief ݒ̃NA
 * @param lst_stt
 */
void clear_FindStt(flist_stt *lst_stt);

/**
 * @brief ݒ̕ۑ
 * @param fnam t@C
 * @param lst_stt
 * @return true
 * @return false
 */
bool save_FindSettings(UnicodeString fnam, flist_stt *lst_stt);

/**
 * @brief ݒ̓Ǎ
 * @param fnam t@C
 * @param lst_stt
 * @return true
 * @return false
 */
bool load_FindSettings(UnicodeString fnam, flist_stt *lst_stt);

/**
 * @brief ݒ̎擾
 * @param fnam t@C
 * @param[out] lst 񃊃Xg
 */
void get_FindSetInf(UnicodeString fnam, TStringList *lst);

/**
 * @brief ΏۂŜH
 * @param lst_stt
 * @return true
 * @return false
 */
bool is_FindAll(flist_stt *lst_stt);

/**
 * @brief Xg񕶎擾
 * @param pnam_sw pXȂǂt
 * @return UnicodeString
 */
UnicodeString get_FindInfStr(bool pnam_sw);

bool check_int(int v0, int v1, int mode);
bool check_prop(UnicodeString fnam, UnicodeString prop, int v, int mode);

/**
 * @brief Wt@C
 * @attention sȐK\p^[pȂ(vO`FbN)
 * @param fnam pXt@C
 * @param f_tm ^CX^v
 * @param f_sz TCY
 * @param f_atr 
 * @param lst_stt
 * @return true }b`
 * @return false
 */
bool check_file_std(UnicodeString fnam, TDateTime f_tm, __int64 f_sz, int f_atr, flist_stt *lst_stt);

/**
 * @brief gt@C
 * @param fnam pXt@C
 * @param lst_stt
 * @return true }b`
 * @return false
 */
bool check_file_ex(UnicodeString fnam, flist_stt *lst_stt);

/**
 * @brief tHg擾
 * @param fnam t@C
 * @param[out] lst 񃊃Xg
 * @return UnicodeString tHg
 */
UnicodeString get_FontInf(UnicodeString fnam, TStringList *lst = NULL);

drive_info *get_DriveInfoList();
drive_info *get_DriveInfo(UnicodeString dstr);
void update_DriveInfo();
bool is_NTFS_Drive(UnicodeString dnam);
UnicodeString get_VolumeInfo(UnicodeString dnam, UnicodeString *fsys = NULL);

UnicodeString mount_VirDriveList(int idx);
UnicodeString get_VirMountDir(UnicodeString drv);
UnicodeString cv_VirToOrgName(UnicodeString fnam);
bool is_ExePath(UnicodeString pnam);

void get_DriveLogList(UnicodeString dstr, TStringList *lst, double &r_min, double &r_max);
void update_DriveLog(bool save = false);

bool save_RenLog(TStringList *lst);

void set_ListBoxItemHi(TListBox      *lp, TFont *font = NULL, bool with_ico = false);
void set_ListBoxItemHi(TCheckListBox *lp, TFont *font = NULL, bool with_ico = false);

void set_StdListBox(TListBox      *lp, int tag = 0, TFont *font = NULL, bool with_ico = false);
void set_StdListBox(TCheckListBox *lp, int tag = 0, TFont *font = NULL, bool with_ico = false);

void setup_ToolBar(TToolBar *tb, bool upd_sw = false);
void setup_Panel(TPanel *sb, TFont *font = NULL);

void set_UsrScrPanel(UsrScrollPanel *sp);
void set_FextWidth(file_rec *fp, int tag);

void assign_FileListBox(TListBox *lp, TStringList *lst, int idx = -1, UsrScrollPanel *sp = NULL);
void update_FileListBox(TStrings *lst, int tag, int idx = -1);
void update_FileListBoxT(TStrings *lst, int tag);

bool get_Files_objSize(UnicodeString pnam, TStrings *lst, bool exc_sym);
bool get_NameList_objSize(TStringList *lst, TStringList *o_lst, bool sub_sw, bool exc_sym);

/**
 * @brief fBNg̃Xg擾
 * @param id
 * @param[out] o_lst Xg
 * @return true
 * @return false
 */
bool get_SpecialDirList(UnicodeString id, TStringList *o_lst = NULL);

void get_FindListF(UnicodeString pnam, flist_stt *lst_stt, TStrings *lst, int tag);
void get_FindListD(UnicodeString pnam, flist_stt *lst_stt, TStrings *lst, int tag);

/**
 * @brief ׂẴTufBNg擾
 * @param pnam fBNg
 * @param[out] lst fBNgXg
 * @param stt_bar oߕ\pXe[^Xo[
 * @param stt_idx \pl̃CfbNX
 * @param proc_msg bZ[WL[
 */
void get_SubDirs(UnicodeString pnam, TStrings *lst, TStatusBar *stt_bar = NULL, int stt_idx = 0, bool proc_msg = false);

int  get_HardLinkList(UnicodeString fnam, TStringList *o_lst);
UnicodeString get_ReparsePointTarget(UnicodeString pnam, bool &is_jct, bool force = false);

__int64 get_DirSize(UnicodeString dnam, int *f_cnt, int *d_cnt, __int64 *o_size, __int64 *c_size);
__int64 get_ArcDirSize(UnicodeString anam, UnicodeString dnam, int *f_cnt, int *d_cnt);

void  del_CachedIcon(UnicodeString fnam);
void  clr_all_CachedIcon();

HICON get_file_SmallIcon(UnicodeString fnam);
HICON get_fext_SmallIcon(UnicodeString fext = EmptyStr);
HICON get_folder_icon(UnicodeString dnam = EmptyStr);

bool draw_SmallIcon(file_rec *fp, TCanvas *cv, int x, int y, bool force_cache = false, TControl *cp = NULL);
bool draw_SmallIconF(UnicodeString fnam, TCanvas *cv, int x, int y, TControl *cp = NULL);
bool draw_SmallIcon2(UnicodeString fnam, TCanvas *cv, int x, int y, TControl *cp = NULL);
int  add_IconImage(UnicodeString fnam, TImageList *lst);
int  add_IconImage(UnicodeString fnam, TVirtualImageList *lst);

UnicodeString get_file_from_cmd(UnicodeString s);
void SetExtNameToCtrl(UnicodeString fnam, TWinControl *cp, bool nbt_sw = false);

bool load_MenuFile(UnicodeString fnam, TStringList *lst);

bool load_WorkList(UnicodeString wnam);
bool save_WorkList(UnicodeString wnam, TStringList *lst = NULL);

bool load_FontSample(UnicodeString fnam);
bool save_FontSample(UnicodeString fnam);

int  find_NextIncSea(TStringList *lst, int idx);
int  find_PrevIncSea(TStringList *lst, int idx);
int  find_NextIniSea(TStringList *lst, int idx, UnicodeString keywd = EmptyStr, bool circular = true);

int  to_NextFile(TStringList *lst, int idx);
int  to_PrevFile(TStringList *lst, int idx);
int  to_NextSelItem(TStringList *lst, int idx);
int  to_PrevSelItem(TStringList *lst, int idx);

/**
 * @brief ViewFileList ŗLȍڐ擾
 * @return int
 */
int  get_ViewCount();

bool make_NrmImage(UnicodeString fnam, Graphics::TBitmap *c_bmp, Graphics::TBitmap *g_bmp, int wd, int hi, bool cc_sw);
UnicodeString make_HsvVector(Graphics::TBitmap *i_bmp);
UnicodeString make_HistVector(Graphics::TBitmap *i_bmp);
UnicodeString make_dHash(Graphics::TBitmap *i_bmp);
UnicodeString make_aHash(Graphics::TBitmap *i_bmp);
UnicodeString make_pHash(Graphics::TBitmap *i_bmp);
int eval_HsvVector(UnicodeString r_vct, UnicodeString o_vct);
int eval_HistgramVector(UnicodeString r_vct, UnicodeString o_vct);
int get_HammingDistance(UnicodeString vct0, UnicodeString vct1);

/**
 * @brief t@C̍폜
 * @param fnam t@C
 * @param use_trash ݔgp
 * @return true 
 * @return false
 */
bool delete_File(UnicodeString fnam, bool use_trash = false);

void delete_FileIf(UnicodeString fnam);

bool delete_DirEx(UnicodeString pnam, bool use_trash = false, bool force = false);

/**
 * @brief t@C̈ړ(^O/tH_ACRl)
 * @param old_nam ړ̃t@C
 * @param new_nam ړ̃t@C
 * @return true 
 * @return false
 */
bool move_FileT(UnicodeString old_nam, UnicodeString new_nam);

/**
 * @brief tH_ACR̈ړ
 * @param old_dnam
 * @param new_dnam
 */
void move_FolderIcon(UnicodeString old_dnam, UnicodeString new_dnam);

/**
 * @brief tH_ACR̃Rs[
 * @param src_dnam
 * @param dst_dnam
 */
void copy_FolderIcon(UnicodeString src_dnam, UnicodeString dst_dnam);

/**
 * @brief tH_ACRt@C̎擾
 * @param dnam
 * @return UnicodeString
 */
UnicodeString get_FolderIconName(UnicodeString dnam);

/**
 * @brief tH_ACR̐ݒ
 * @param dnam fBNg
 * @param inam ACRt@C (EmptyStr: )
 */
void set_FolderIcon(UnicodeString dnam, UnicodeString inam = EmptyStr);

/**
 * @brief tH_ACRꗗ擾
 * @param[out] lst Xg
 */
void get_FolderIconList(TStringList *lst);

/**
 * @brief tH_ACR̉
 * @param old_nam
 * @param new_nam
 */
void rename_FolderIcon(UnicodeString old_nam, UnicodeString new_nam);

/**
 * @brief ݂ȂtH_ACRݒ𐮗
 */
void chk_FolderIcon();

/**
 * @brief gqɊ֘AtĂAṽXg擾
 * @param fext gq
 * @return TStringDynArray
 */
TStringDynArray get_AssociatedApps(UnicodeString fext);

/**
 * @brief ֘AtXg烁j[pXg쐬
 * @param[in] app_lst ֘AtXg
 * @param[out] lst j[pXg
 */
void make_AssoMenuList(TStringDynArray app_lst, TStringList *lst);

/** @addtogroup GLOBAL_COLORS */
/** @{ */
/**
 * @brief t@CXgڂ̔wiF擾
 * @param lst_stt
 * @param idx CfbNX
 * @return TColor
 */
TColor get_FlBgColor(flist_stt *lst_stt, int idx = 0);

/**
 * @brief t@C̕F擾
 * @param fp
 * @param col_x
 * @return TColor
 */
TColor get_FileColor(file_rec *fp, TColor col_x);

/**
 * @brief gqʃJ[擾
 * @param fext gq
 * @param col ftHgF
 * @return TColor
 */
TColor get_ExtColor(UnicodeString fext, TColor col = col_fgList);

/**
 * @brief ^CX^v̕F擾
 * @param dt ^CX^v
 * @param col_def ftHgF
 * @return TColor
 */
TColor get_TimeColor(TDateTime dt, TColor col_def);

/**
 * @brief TCY̕F擾
 * @param size TCY
 * @param col_def ftHgF
 * @return TColor
 */
TColor get_SizeColor(__int64 size, TColor col_def);

/**
 * @brief O̕F擾
 * @param s 
 * @return TColor
 */
TColor get_LogColor(UnicodeString s);
/** @} */

UnicodeString get_DirNwlName(UnicodeString pnam);
UnicodeString get_DispName(file_rec *fp);
UnicodeString get_RegDirName(UnicodeString pnam);
UnicodeString UNC_to_NetDriveName(UnicodeString pnam);
UnicodeString NetDriveName_to_UNC(UnicodeString pnam);
UnicodeString VirtualDrive_to_Actual(UnicodeString pnam);
UnicodeString get_RegDirItem(int idx, UnicodeString *unam = NULL);
UnicodeString get_RegDirItem(WideChar key, UnicodeString *unam = NULL);
void move_top_RegDirItem(int idx);
UnicodeString get_LRUD_str(int tag = CurListTag, bool both = false);

/**
 * @brief 폜ꂽfBNgH
 * @param dnam 
 * @return true 
 * @return false 
 */
bool is_ProtectDir(UnicodeString dnam);

/**
 * @brief t@C񃊃Xg擾
 * @param fp 擾Ώ
 * @param force IɎ擾
 */
void GetFileInfList(file_rec *fp, bool force = false);

/**
 * @brief w肵t@C̒l擾
 * @param fp 擾Ώ
 * @param tit ^Cg
 * @param dlmt l̋؂蕶
 * @return UnicodeString 
 */
UnicodeString get_FileInfValue(file_rec *fp, UnicodeString tit, UnicodeString dlmt = EmptyStr);

void assign_InfListBox(TListBox *lp, TStringList *i_lst, UsrScrollPanel *sp = NULL);
void draw_InfListBox(TListBox *lp, TRect &Rect, int Index, TOwnerDrawState State);
void draw_ColorListBox(TListBox *lp, TRect &Rect, int Index, TOwnerDrawState State, TStringList *col_lst);

void draw_InputPaintBox(TPaintBox *pp, UnicodeString s);

/**
 * @brief ^CX^v̕\擾
 * @param dt 
 * @return UnicodeString 
 */
UnicodeString get_TimeStampStr(TDateTime dt);

UnicodeString get_FileSizeStr(__int64 sz, bool trim = false);
UnicodeString get_FileSizeStrF(__int64 sz);
UnicodeString get_FileInfStr(file_rec *fp, bool with_atr = true);
UnicodeString get_FileInfStr(UnicodeString fnam, bool with_atr = true);
void get_FileNamePathInf(UnicodeString fnam, TStringList *lst, bool get_app = false);

/**
 * @brief t@C񃊃Xg擾
 * @param fp 擾Ώ
 * @param[out] lst 񃊃Xg
 * @return true
 * @return false
 */
bool get_FileInfList(file_rec *fp, TStringList *lst);

/**
 * @brief t@CH
 * @param fp Ώ
 * @param[out] err_msg G[bZ[W
 * @return true
 * @return false
 */
bool is_Processing(file_rec *fp, UnicodeString *err_msg = NULL);

/**
 * @brief t@CH
 * @param fnam t@C
 * @param is_video (`FbN)
 * @param[out] err_msg G[bZ[W
 * @return true
 * @return false
 */
bool is_Processing(UnicodeString fnam, bool is_video = false, UnicodeString *err_msg = NULL);

/**
 * @brief 擾}~ĂpXH
 * @param pnam pX
 * @param no_path 擾ȂpX̃Xg(ϐA%ExePath% Ή)
 * @return true
 * @return false
 */
bool is_NoInfPath(UnicodeString pnam, UnicodeString no_path);

/**
 * @brief Xg[̉sR[h擾
 * @param ms Xg[
 * @param code_page R[hy[W
 * @param strict S`FbN
 * @return UnicodeString
 */
UnicodeString get_StreamLineBreak(TStream *ms, int code_page, bool strict = false);

/**
 * @brief t@C̃R[hy[W擾
 * @param fnam t@C
 * @param[out] line_brk s
 * @param[out] has_bom BOML
 * @return int R[hy[W (0: s)
 */
int get_FileCodePage(UnicodeString fnam, UnicodeString *line_brk = NULL, bool *has_bom = NULL);

/**
 * @brief t@C̓eLXgH
 * @param fnam t@C
 * @param[out] code_page R[hy[W
 * @param[out] line_brk s
 * @param[out] has_bom BOML
 * @return true
 * @return false
 */
bool is_TextFile(UnicodeString fnam, int *code_page = NULL, UnicodeString *line_brk = NULL, bool *has_bom = NULL);

/**
 * @brief 񃊃Xg̍sARgA󔒍sJEg
 * @param lst 񃊃Xg
 * @param fnam t@C
 * @param[out] rem_cnt Rgs
 * @param[out] blk_cnt 󔒍s
 * @return int s
 */
int CountListLines(TStringList *lst, UnicodeString fnam, int *rem_cnt, int *blk_cnt);

/**
 * @brief INIt@C̃^Cv擾
 * @param fp Ώ
 * @return UnicodeString ^Cv
 */
UnicodeString get_IniTypeStr(file_rec *fp);

/**
 * @brief ݒt@CH
 * @param fp Ώ
 * @return true
 * @return false
 */
bool is_FindSet(file_rec *fp);

/**
 * @brief j[t@CH
 * @param fp Ώ
 * @return true
 * @return false
 */
bool is_MenuFile(file_rec *fp);

/**
 * @brief ʃXgt@CH
 * @param fp Ώ
 * @return true
 * @return false
 */
bool is_ResultList(file_rec *fp);

bool is_AudioVideo(UnicodeString fnam);		//!< rfI/I[fBIEt@CH
bool is_MPEG2_TS(UnicodeString fnam);		//!< MPEG-2 TS t@CH
bool is_SoundID(UnicodeString s);			//!< TEhʎqH
bool is_ViewableFext(UnicodeString fext);	//!< r[Aŕ\\(ACR͏)H
bool is_Viewable(file_rec *fp);
bool is_ExtractIcon(file_rec *fp);			//!< ACRo\H
bool test_ArcExt(UnicodeString fext);		//!< A[JCȏΉgqH
bool is_AvailableArc(UnicodeString fnam, bool ex_sw = false);	//!< p\ȃA[JCuH

bool test_TxtFile(UnicodeString fnam);		//!< eLXgt@CH
bool test_NonTxtExt(UnicodeString fext);	//!< eLXg̊gqH

UnicodeString get_img_fext();				//!< 摜̊gq擾

/**
 * @brief gqʃt@Cǉ
 * @param f_lst t@CXg
 * @param[out] lst 񃊃Xg
 */
void add_FExtInfList(TStringList *f_lst, TStringList *lst);

/**
 * @brief t@C摜TCY擾
 * @param fnam t@C
 * @param[out] wd 
 * @param[out] hi 
 * @return true 
 * @return false
 */
bool get_img_size(UnicodeString fnam, unsigned int *wd, unsigned int *hi);

/**
 * @brief 摜t@Cǂݍ
 * @param fnam t@C
 * @param[out] o_bmp rbg}bv
 * @param img_type
 * @param trans_bg ߔwiF
 * @return int
 */
int  load_ImageFile(UnicodeString fnam, Graphics::TBitmap *o_bmp, int img_type = WICIMG_PREVIEW, TColor trans_bg = col_None);

/**
 * @brief TlCLbV擾
 * @param fnam t@C
 * @param[out] o_bmp rbg}bv
 * @return UnicodeString t@C [TAB] \
 */
UnicodeString load_ImageThumbCache(UnicodeString fnam, Graphics::TBitmap *o_bmp);

/**
 * @brief O[oϐȂǂ̏
 */
void InitializeGlobal();

/**
 * @brief Еt
 */
void EndGlobal();

/**
 * @brief OSo[W擾
 * @return UnicodeString 
 */
UnicodeString get_OsVerInfStr();

/** @brief ^C}[ݒ̍XV */
void SetupTimer();

/** @brief Ԃ̉ */
void ClearNopStt();

/** @brief IvVݒ̓ǂݍ */
void LoadOptions();

/** @brief IvVݒ̕ۑ */
void SaveOptions();

/** @brief INIt@CXV */
void UpdateIniFile(UsrIniFile *ini_file);

void BringOptionByTag(TForm *fp);
int  GetOptionIntDef(int tag);
void ApplyOptionByTag(TComponent *cp);
void ApplyOptionByTag(TForm *fp);
void ApplyOptionByTag(TTabSheet *sp);
void ApplyOptionByTag(TPanel *pp);

void SetToolWinBorder(TForm *fp, bool sw = true, TColor col = col_TlBorder);

/** @brief ꗗpObh̏ */
void InitializeListGrid(TStringGrid *gp, TFont *font = NULL);

/** @brief ꗗpwb_̏ */
void InitializeListHeader(THeaderControl *hp, const _TCHAR *hdr, TFont *font = NULL);

void set_ComboBox_AutoComp(TForm *frm);
void set_MigemoCheckBox(TCheckBox *cp, const _TCHAR *key, UnicodeString sct = EmptyStr);
void set_MigemoAction(TAction *ap, const _TCHAR *key, UnicodeString sct = EmptyStr);
void change_ComboBoxHistory(TComboBox *cp, const _TCHAR *nrm_sct, const _TCHAR *reg_sct, bool reg_sw);

/**
 * @brief Xg̍i荞
 * @param i_lst ΏۃXg
 * @param[out] o_lst ʃXg 
 * @param kwd 
 * @param opt IvV
 */
void filter_List(TStringList *i_lst, TStringList *o_lst, UnicodeString kwd, SearchOption opt);

/** @brief L[Ɋ蓖ĂĂt@C[ER}h擾 */
UnicodeString Key_to_CmdF(UnicodeString key);

/** @brief L[Ɋ蓖ĂĂeLXgr[AER}h擾 */
UnicodeString Key_to_CmdV(UnicodeString key);

bool is_ToLeftOpe(UnicodeString keystr, UnicodeString cmdstr);
bool is_ToRightOpe(UnicodeString keystr, UnicodeString cmdstr);

/**
 * @brief R}hɑ΂擾
 * @param cmd R}h
 * @param only_inf ̂ݎ擾
 * @param menu_list ǉj[
 * @param tool_list Oc[
 * @param is_TV eLXgr[AER}h
 * @return UnicodeString 
 */
UnicodeString get_CmdDesc(UnicodeString cmd, bool only_inf = false,
	TStrings *menu_list = NULL, TStrings *tool_list = NULL, bool is_TV = false);

/** @brief ֎~^[U`̕ϊ */
UnicodeString ApplyCnvCharList(UnicodeString s);

TColor read_ColorList(UnicodeString key, TColor def, TStringList *lst = NULL);
TColor read_ColorList(const _TCHAR *key, TColor def, TStringList *lst = NULL);
void set_col_from_ColorList();

/** @brief ҏWǉ */
void add_TextEditHistory(UnicodeString fnam);

/** @brief ĂяozbgL[̓o^ */
bool register_HotKey(int id, UnicodeString kstr);

void set_FormTitle(TForm *frm, const _TCHAR *s);

/** @brief x */
void beep_Warn(UnicodeString fnam = EmptyStr);

/** @brief ^Cgo[̓_ */
void flash_win(int cnt = 0, int tm = 0);

/** @brief ʃ~[g */
bool mute_Volume(UnicodeString prm);

/** @brief TEhĐ */
bool play_sound(UnicodeString fnam);
bool play_sound_id(UnicodeString id);
bool play_sound_ex(UnicodeString fnam, bool limit = true);

bool add_PlayFile(UnicodeString fnam);
bool add_PlayList(UnicodeString lnam);
bool play_PlayList(bool prev = false, bool inh_shfl = false);
bool is_ListPlaying();

void set_CloseButton(bool enabled);

/**
 * @brief ^ulĕ񕝂擾
 * @param s Ώە
 * @param cv LoX
 * @param tab_wd ^uXgbv
 * @return int 
 */
int  get_TabTextWidth(UnicodeString s, TCanvas *cv, int tab_wd);

void out_Text(TCanvas *cv, int x, int y, const _TCHAR *s);
void out_Text(TCanvas *cv, int x, int y, const _TCHAR *s, TColor fg);
void out_TextEx(TCanvas *cv, int &x, int y, UnicodeString s, TColor fg = col_None, TColor bg = col_None, int mgn = 0);
void out_TextRect(TCanvas *cv, TRect &rc, UnicodeString s, TColor fg = col_None, TColor bg = col_None);

/**
 * @brief ɑ΂}b`̃Xg擾
 * @param lbuf Ώە
 * @param kwd 
 * @param opt IvV
 * @param[out] lst }b`ꃊXg
 * @return int }b` 
 */
int get_MatchWordList(UnicodeString lbuf, UnicodeString kwd, SearchOption opt, TStringList *lst);

int get_MatchWordListEx(UnicodeString lbuf, UnicodeString kwd, SearchOption opt, TStringList *lst,
							int s_idx = 0, int s_len = 0);

void EmphasisTextOut(UnicodeString s, TStringList *kw_lst, TCanvas *cv, int &x, int y, bool case_sns = false);

enum TxtOutOpt {toNormal, toCaseSens, toOnlyTop, toCompBgCol, toIsDfm, toTrimLeft};
typedef Set <TxtOutOpt, toNormal, toTrimLeft> TxtOutOption;

void EmphasisTextOutEx(UnicodeString s, TStringList *kw_lst, TCanvas *cv, int &x, int y, TxtOutOption opt,
	TColor fg = col_fgEmp, TColor bg = col_bgEmp);
void EmphasisTextOutEx(UnicodeString s, UnicodeString kwd, TCanvas *cv, int &x, int y, TxtOutOption opt,
	TColor fg = col_fgEmp, TColor bg = col_bgEmp);

void draw_TAB(TCanvas *cv, int x, int y, int w, int h);
void draw_CR(TCanvas *cv, int x, int y, int w, int h);
void draw_Caret(TCanvas *cv, int x, int y);

void TabCrTextOut(UnicodeString s, TCanvas *cv, int &x, int y, TColor fg = col_fgList, int max_x = 0);
void RuledLnTextOut(UnicodeString s, TCanvas *cv, TRect &rc, TColor fg, int tab_wd = 8,
	TStringList *kw_lst = NULL, bool case_sns = false);

void PrvTextOut(TListBox *lp, int idx, TCanvas *cv, TRect &rc, TColor fg,
	int tab_wd, TStringList *kw_lst = NULL, bool case_sns = false, UnicodeString fnam = EmptyStr, bool en_mlt = true);

void LineNoOut(TCanvas *cv, TRect &rc, UnicodeString l_str);
void LineNoOut(TCanvas *cv, TRect &rc, int l_no);

void PathNameOut(UnicodeString s, TStringList *kw_lst, bool case_sns, TCanvas *cv, int &x, int y, bool mgn_sw = true);
void PathNameOut(UnicodeString s, TCanvas *cv, int &x, int y, int max_w = 0);
void FileNameOut(TCanvas *cv, TRect &rc, UnicodeString fnam, bool use_fgsel,
	bool to_slash = false, TStringList *kw_lst = NULL, bool case_sns = false);

void RloPipeTextOut(UnicodeString s, TCanvas *cv, int &x, int y, TColor fg);
void SpaceTextOut(UnicodeString s, TCanvas *cv, int &x, int y, TColor fg, bool force_nrm = false);

void Emphasis_RLO_info(UnicodeString fnam, TCanvas *cv, int xp, int yp);

//---------------------------------------------------------------------------
#define UBMK_UP		1
#define UBMK_DOWN	2
#define UBMK_BUP	3
#define UBMK_BDOWN	4
#define UBMK_VUP	5
#define UBMK_VDOWN	6
#define UBMK_VTOP	7
#define UBMK_VEND	8
#define UBMK_HTOP	9
#define UBMK_HEND	10
#define UBMK_LEFT	11
#define UBMK_RIGHT	12

void draw_SortMark(TCanvas *cv, int x, int y, bool is_asc, TColor fg = Graphics::clNone);
void draw_SortHeader(THeaderControl *hp, THeaderSection *sp, TRect rc, int mk_mode = 0, bool use_syscol = false);
void draw_ScaledLine(TCanvas *cv, UnicodeString cmds);
void set_ButtonMark(TSpeedButton *bp, int id, TColor fg, TColor bg);
void set_BtnMarkStyle(TSpeedButton *bp, int id);
void set_BtnTextStyle(TSpeedButton *bp, UnicodeString s);

void draw_OwnerTab(TCustomTabControl *Control, int idx, const TRect rc, bool active);
void draw_MenuSeparator(TCanvas *cv, TRect rc);
void draw_ListCursor(TListBox *lp, TRect &Rect, int Index, TOwnerDrawState State);
void draw_ListCursor2(TListBox *lp, TRect &Rect, int Index, TOwnerDrawState State);
void draw_GridCursor(TStringGrid *gp, TRect &Rect, int ARow, TGridDrawState State);
void draw_ImgGrid(TCanvas *cv, Graphics::TBitmap *bmp);
void draw_BarGraph(TCanvas *cv, TRect rc, double r);
void draw_ProgressBar(TCanvas *cv, TRect rc, double r);

bool saveto_TextUTF8(UnicodeString fnam, TStrings *lst);
bool saveto_TextUTF8(UnicodeString fnam, UnicodeString s);
bool saveto_TextFile(UnicodeString fnam, TStrings *lst, TEncoding *enc = NULL);
bool saveto_TextFile(UnicodeString fnam, TStrings *lst, int enc_idx);

int  load_text_ex(UnicodeString fnam, TStringList *f_buf, int code_page = 0, int limit_size = 0,
	bool force_txt = false, UnicodeString *line_brk = NULL, bool *has_bom = NULL, double *ave_lsz = NULL);

int  load_text_tail(UnicodeString fnam, TStringList *f_buf, int code_page = 0, int limit_ln = 100,
	bool reverse = false, UnicodeString *line_brk = NULL);
bool check_text_tail(UnicodeString fnam, int &code_page, int size, UnicodeString kwd, TStringList *lst);

void get_xml_inf(UnicodeString fnam, TStringList *lst);

UnicodeString get_autorun_ico(UnicodeString fnam);

bool divide_FileName_LineNo(UnicodeString &fnam, int &lno, UnicodeString rnam, int pos = 0);
UnicodeString get_tags_file(UnicodeString rnam);
int  get_FileNameByTag(UnicodeString tnam, UnicodeString &rnam, TStringList *lst, UnicodeString onam = EmptyStr);

/** @brief eLXgGfB^ŊJ */
bool open_by_TextEditor(UnicodeString fnam, int lno = 0);

void ini_HtmConv_def(HtmConv *htmcnv, UnicodeString fnam = EmptyStr, UnicodeString url = EmptyStr);

/**
 * @brief wt@Cs/J
 * @param cmd st@C/tH_/CLSId Ȃ
 * @param prm p[^
 * @param wdir ƃfBNg
 * @param opt IvV
 * @param[out] exit_code IR[h
 * @param[out] o_lst o̓Xg
 * @return true 
 * @return false 
 */
bool Execute_ex(UnicodeString cmd, UnicodeString prm = EmptyStr, UnicodeString wdir = EmptyStr,
		UnicodeString opt = EmptyStr, DWORD *exit_code = NULL, TStringList *o_lst = NULL);

/**
 * @brief R}hCs
 * @param cmdln R}hC
 * @param wdir ƃfBNg
 * @param opt IvV
 * @param[out] exit_code IR[h
 * @param[out] o_lst o̓Xg
 * @param[out] o_ms o̓C[W 
 * @param rq_abort fv
 * @return true 
 * @return false 
 */
bool Execute_cmdln(UnicodeString cmdln, UnicodeString wdir = EmptyStr,
		UnicodeString opt = EmptyStr, DWORD *exit_code = NULL, TStringList *o_lst = NULL, TMemoryStream *o_ms = NULL,
			bool *rq_abort = NULL);

/**
 * @brief ʃ[Uɍ~iĎs
 * @param cmd R}h
 * @param prm p[^
 * @param wdir ƃfBNg
 * @return true 
 * @return false 
 */
bool Execute_demote(UnicodeString cmd, UnicodeString prm = EmptyStr, UnicodeString wdir = EmptyStr);

/**
 * @brief git.exe s
 * @param prm p[^
 * @param wdir ƃfBNg
 * @param[out] o_lst o̓Xg
 * @param[out] exit_cd IR[h
 * @param[out] w_lst xXg(o͂番Ď擾) 
 * @param rq_abort fv
 * @return true 
 * @return false 
 */
bool GitShellExe(UnicodeString prm, UnicodeString wdir, TStringList *o_lst, DWORD *exit_cd = NULL,
		TStringList *w_lst = NULL, bool *rq_abort = NULL);
bool GitShellExe(UnicodeString prm, UnicodeString wdir, TMemoryStream *o_ms, DWORD *exit_cd = NULL);
bool GitShellExe(UnicodeString prm, UnicodeString wdir);
void split_GitWarning(TStringList *o_lst, TStringList *w_lst = NULL);

/** @brief w胊rW̃t@CꎞfBNgɕۑ */
UnicodeString save_GitRevAsTemp(UnicodeString id, UnicodeString fnam, UnicodeString wdir);

/**
 * @brief grep.exe s
 * @param prm p[^
 * @param wdir ƃfBNg
 * @param[out] o_lst o̓Xg
 * @param[out] exit_cd IR[h
 * @param[out] rq_abort fv
 * @return true 
 * @return false 
 */
bool GrepShellExe(UnicodeString prm, UnicodeString wdir, TStringList *o_lst, DWORD *exit_cd = NULL, bool *rq_abort = NULL);

/** @brief s/ҋ@̃^XN擾 */
int  get_BusyTaskCount();

/** @brief s܂ލő^XN擾 */
int  get_MaxTaskCount();

/**
 * @brief 󂫃^XN邩H
 * @param ex_sw ő^XN𒴂Ď擾
 * @return true 
 * @return false 
 */
bool has_EmptyTask(bool ex_sw = false);

/**
 * @brief ^XNXbh擾
 * @param cp ^XNݒ
 * @param reserve \񂷂
 * @param force ۗł擾
 * @param ext_sw ő^XN𒴂Ď擾
 * @return TTaskThread* 
 */
TTaskThread * CreTaskThread(TaskConfig **cp, bool reserve = true, bool force = false, bool ext_sw = false);

/** ^XN̊Jn܂͗\ */
void ActivateTask(TTaskThread *tp, TaskConfig *cp);

/** \ۗڂ̎s */
void StartReserve();
bool StartReserve(int idx, bool ext_sw = false);

/** @brief ^XNɒᑬsv */
void RequestSlowTask();

/** @brief ^XNŏ̃t@CH */
bool is_OnTask(UnicodeString fnam);

UnicodeString get_LogErrMsg(UnicodeString msg = EmptyStr, bool add_cr = true, UnicodeString fnam = EmptyStr, int err_id = NO_ERROR);
void set_LogErrMsg(UnicodeString &msg, UnicodeString s = EmptyStr, UnicodeString fnam = EmptyStr, int err_id = NO_ERROR);

int get_TopMargin(TCanvas *cv);
int get_TopMargin2(TCanvas *cv);

/** @brief vplp擾 */
UnicodeString GetClockStr();

/** @brief R}ht@C̉IvVݒɔf */
void RenameOptCmdFile();

/** @brief R}ht@C̎QƏ擾 */
UnicodeString get_ref_CmdFile(UnicodeString fnam, TStringList *lst = NULL);

/** @brief GCAXQƂĂL[擾(J}؂蕶) */
UnicodeString get_Alias_KeyStr(UnicodeString alias, TStringList *k_lst = NULL);

/** @brief pOăp[^𒊏o */
UnicodeString extract_ExeParam(UnicodeString prm, UnicodeString *dsc = NULL);

UnicodeString make_PathMask(UnicodeString mask, UnicodeString def_desc = EmptyStr);

UnicodeString make_LogHdr(UnicodeString cmd, UnicodeString fnam = EmptyStr, bool is_dir = false, int wd = 0);
UnicodeString make_LogHdr(const _TCHAR *cmd, UnicodeString fnam = EmptyStr, bool is_dir = false, int wd = 0);
UnicodeString make_LogHdr(const _TCHAR *cmd, file_rec *fp);
UnicodeString make_CreateLog(UnicodeString dnam);
UnicodeString make_RenameLog(UnicodeString o_nam, UnicodeString n_nam);
void cat_DestDir(UnicodeString &msg, UnicodeString dnam);
void cat_DestFile(UnicodeString &msg, UnicodeString fnam);
void set_RenameLog(UnicodeString &msg, UnicodeString fnam);

/** @brief OXg{bNX̍XV */
void UpdateLogListBox();

void StartLog(UnicodeString msg, int task_no = -1);
void StartLog(const _TCHAR *msg, int task_no = -1);
void EndLog(UnicodeString msg, UnicodeString inf = EmptyStr);
void EndLog(const _TCHAR *msg, UnicodeString inf = EmptyStr);
void EndLog(int id, UnicodeString inf = EmptyStr);
void ExeErrLog(UnicodeString fnam, UnicodeString msg);

UnicodeString get_ResCntStr(int ok_cnt = 0, int er_cnt = 0, int sk_cnt = 0, int ng_cnt = 0, bool is_task = false);

void AddLog(UnicodeString msg, bool with_t = false, bool raw = false);
void AddLog(const _TCHAR *msg, bool with_t = false);
void AddLogStrings(TStringList *lst);
void AddLogCr();
void AddErr_Highlight();
void AddDebugLog(UnicodeString msg, UnicodeString info = EmptyStr, UnicodeString info2 = EmptyStr);
void FlushLog();

bool __fastcall SpecialKeyProc(TForm *frm, WORD &Key, TShiftState Shift, const _TCHAR *topic = NULL);
bool __fastcall SpecialKeyProc(TForm *frm, WORD &Key, TShiftState Shift, int hlp_cnt);

bool __fastcall SpecialEditProc(TObject *Sender, WORD &Key, TShiftState Shift);

/** @brief fBNg̓{bNX */
UnicodeString inputbox_dir(const _TCHAR *tit, const _TCHAR *cmd);

bool is_FirstKey(UnicodeString id, UnicodeString keystr);
bool is_IniSeaKey(UnicodeString &keystr);

bool update_IncSeaWord(UnicodeString &kwd, UnicodeString keystr, bool fl_sw = false);

bool is_OneNrmCmd(UnicodeString cmds, bool no_prm = false);

bool MovListBoxFromFilter(TListBox *lp, UnicodeString key_str);
bool MovGridFromFilter(TStringGrid *gp, UnicodeString key_str);

/** @brief Xg{bNXł̃R}h */
bool ExeCmdListBox(TListBox *lp, UnicodeString cmd, UnicodeString prm = EmptyStr);

void copy_to_Clipboard(UnicodeString s);
void copy_to_Clipboard(TPicture *pic);
void copy_to_Clipboard(TMetafile *mf);
void copy_to_Clipboard(Graphics::TBitmap *bmp);

int  get_GenWndList(TStringList *lst);

bool CloseOtherNyanFi();
int  get_NyanFiList(TStringList *lst);
UnicodeString get_NewTitle(bool primary = false);
HWND get_NyanFiWnd(int rel_idx);
bool activate_NyanFi(int idx, bool rel = true);
bool IsDuplicated();

int  get_ExViewerList(TStringList *lst);
bool focus_ExViewer();
void close_all_ExViewer(TForm *frm = NULL);

/**
 * @brief ŏɋNꂽ NyanFi ̃nh擾
 * @return HWND 
 */
HWND get_PrimNyanWnd();

/**
 * @brief NyanFi ̃CʂH
 * @param hWnd 
 */
bool IsNyanfiWnd(HWND hWnd);

/**
 * @brief dNꂽ NyanFi ̃CʂH
 * @param hWnd 
 */
bool IsNyanfi2Wnd(HWND hWnd);

/**
 * @brief ŏɋNꂽ NyanFi ɕ𑗏o
 * @param msg 
 * @return true 
 * @return false 
 */
bool NotifyPrimNyan(UnicodeString msg);

HWND get_ModalWnd();
HWND get_HelpWnd();
HWND get_MenuWnd();

double GetDistance(double lat1, double lng1, double lat2, double lng2);
bool OpenWebMaps(double lat, double lng, UnicodeString fnam, int map_idx, int zoom, UnicodeString tnam = EmptyStr);

UnicodeString cipher(UnicodeString orgstr);
UnicodeString uncipher(UnicodeString cipstr);

void AddToRecentFile(UnicodeString fnam);
void AddToRecentFile(TStringList *lst);

int get_ViewTabWidth(UnicodeString fext);

/**
 * @brief c[Xg()쐬
 * @param lst 
 * @param pnam 
 * @param chk_sw `FbN
 */
void MakeTreeList(TStringList *lst, UnicodeString pnam, bool chk_sw = false);
bool AddPathToTreeList(TStringList *lst);

/**
 * @brief R}h̒ǉ
 * @param cmd R}h
 * @param prm p[^
 * @param id ʃ[h
 * @param fnam Ώۃt@C
 */
void AddCmdHistory(UnicodeString cmd, UnicodeString prm = EmptyStr, UnicodeString id = EmptyStr, UnicodeString fnam = EmptyStr);

//Git ֘Å֐
UnicodeString get_GitTopPath(UnicodeString dnam);
UnicodeString get_GitConfig(UnicodeString dnam);
UnicodeString get_GitUrl(file_rec *fp);
int get_GitStatusList(UnicodeString pnam, TStringList *lst, bool full_sw = false);
int get_GitChangedList(UnicodeString pnam, TStringList *lst);
UnicodeString get_GitStatusStr(TStringList *lst, bool *staged = NULL);
UnicodeString get_GitGraphStr(UnicodeString lbuf);
UnicodeString split_GitGraphStr(UnicodeString &lbuf);
void draw_GitGraph(UnicodeString s, UnicodeString s1, UnicodeString s2, TCanvas *cv, TRect &rc,
	bool is_head = false, bool is_wip = false);
void draw_GitTag(TCanvas *cv, int &x, int y, UnicodeString tag, int mgn = 0);
void get_GitInf(UnicodeString dnam, TStringList *lst, bool upd_sw = false, bool ext_sw = false);
UnicodeString get_GitDiffFiles(UnicodeString s, UnicodeString &fnam2);
UnicodeString get_GitDiffFile2(UnicodeString s);

int extract_ver_no(UnicodeString fnam);

//---------------------------------------------------------------------------
/**
 * @brief c[`bv (zFύX̂߂ɃTuNX)
 */
class UsrTooltipWindow : public THintWindow
{
private:
	void __fastcall Paint(void);

public:
	__fastcall UsrTooltipWindow(TComponent* AOwner) : THintWindow(AOwner) {}
};
//---------------------------------------------------------------------------
#endif
