/**
 * @file imgv_thread.h
 * @brief 摜\Xbh 
 */
//---------------------------------------------------------------------------
#ifndef ImgViewThreadH
#define ImgViewThreadH

//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
/**
 * @brief 摜\Xbh
 * 
 * C[Wvr[уC[Wr[A̕\s܂B@n
 * ܂܂ȕ\́AAddRequest \bhŃR}hw肷邱ƂɂĎs܂B@n
 * gpłR}h͈ȉ̒ʂłB@n
 * - CLEAR: ʃNA
 * - REDRAW: ĕ`
 * - RELOAD: [h
 * - WAIT: ҂v
 * - EMPTY: t@CNA
 * - FILE: 摜t@Cw
 * - VIDEO: t@Cw
 * - USEBUF: ACR/tHg/F{Ȃǂw
 * - FITTED: tBbg\
 * - GRAY: O[XP[\
 * - GRID: Obh\
 * - ZOOM: Y[{
 * - ROTATION:  ]/]
 * - EXIFORI: Exif̕
 * 
 */
class TImgViewThread : public TThread
{
private:
	UnicodeString Img_f_name;
	__int64		  Img_f_size;
	TDateTime	  Img_f_time;
	UnicodeString Img_rot_str;		//!< ^t@C̉]E]
	bool ChgPrvCur;					//!< vr[̃}EX|C^ύX

	UnicodeString MsgStr;
	bool MsgIsErr;

	TStringList *RequestList;		//!< L[

	TMultiReadExclusiveWriteSynchronizer *TaskRWLock;

	//XbhZ[tlvpeB
	bool FTaskBusy;
	bool __fastcall GetTaskBusy()
	{
		TaskRWLock->BeginRead();
		bool v = FTaskBusy;
		TaskRWLock->EndRead();
		return v;
	}
	void __fastcall SetTaskBusy(bool Value)
	{
		TaskRWLock->BeginWrite();
		FTaskBusy = Value;
		TaskRWLock->EndWrite();
	}
	__property bool TaskBusy = {read = GetTaskBusy,  write = SetTaskBusy};

	void __fastcall ClearImage();
	void __fastcall DrawImage();
	void __fastcall DrawViewBuff();
	void __fastcall DrawMessage();
	void __fastcall Execute();

public:
	UnicodeString FileName;		//!< v摜t@C
	UnicodeString FileName2;

	bool ReqRedraw;				//!< ĕ`v
	bool ReqReload;				//!< [hv
	bool ReqClear;				//!< ʃNAv
	bool ReqVideo;				//!< (TlC\v)
	bool ReqWait;				//!< MinShowTime ɂ҂v
	bool UseViewBuff;			//!< CŐݒ肳ꂽobt@egp
	int  Rotation;				//!< ]/]v (1,3,4,5)
	int  ExifOri;				//!< Exif ̕
	int  ZoomRatio;				//!< Y[{(%)
	double ZoomRatioF;

	bool Fitted;				//!< tBbg\
	bool GrayScaled;			//!< O[XP[\
	bool ShowGrid;				//!< Obh\

	bool ImgIsWmf;

	Graphics::TBitmap *ImgBuff;		//!< 摜obt@(TCY)
	Graphics::TBitmap *ViewBuff;	//!< \obt@
	Graphics::TBitmap *ChgBuff;
	TMetafile *MetaBuff;			//!< ^t@Cpobt@

	/**
	 * @brief RXgN^
	 * @param CreateSuspended 
	 */
	__fastcall TImgViewThread(bool CreateSuspended);

	bool __fastcall IsReady();
	bool __fastcall IsWaiting();

	/**
	 * @brief L[ɏvǉ
	 * @param cmd R}h
	 * @param prm1 p[^1
	 * @param prm2 p[^2
	 */
	void __fastcall AddRequest(const _TCHAR *cmd, UnicodeString prm1 = EmptyStr, UnicodeString prm2 = EmptyStr);

	/**
	 * @brief L[ɏvǉ
	 * @param cmd R}h
	 * @param prm p[^
	 */
	void __fastcall AddRequest(const _TCHAR *cmd, int prm);
};
//---------------------------------------------------------------------------
#endif
